//
//  CKGmCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CKGmCellDelegate {
    func CKGmCellDelAction(cell:CKGmCell)
    func CKGmCellSelectAction(cell:CKGmCell)
}
class CKGmCell: UITableViewCell {
    var dataArr:Array<GetGoodBatchDataModel>? = []
    
    @IBOutlet weak var select_btn: UIButton!
    @IBOutlet weak var detailLbl: UILabel!
 
    var delegate:CKGmCellDelegate?
    @IBAction func selectAction(_ sender: Any) {
        delegate?.CKGmCellSelectAction(cell: self)
    }
    @IBAction func delAction(_ sender: Any) {
        delegate?.CKGmCellDelAction(cell: self)
    }
    @IBOutlet weak var nameLbl: UILabel!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    let scrollView = UIScrollView()
    let remind_lbl = UILabel()
    override func layoutIfNeeded() {
        let colorName = "#F3F4F8"
        scrollView.bounces = true
        scrollView.frame = CGRect(x: 15.0, y: select_btn.frame.maxY + 3.0, width: ScreenWidth-30.0, height: CGFloat(dataArr!.count) * 30.0 + 38.5)
        scrollView.contentSize = CGSize(width: 495, height: 0)
        self.contentView.addSubview(scrollView)
        
        let titleView = UIView(frame: CGRect(x: 0, y: 0, width: 495, height: 38.5))
        scrollView.addSubview(titleView)
        titleView.backgroundColor = UIColor(named: colorName)
        
        let t1 = UILabel(frame: CGRect(x: 0, y: 0, width: 110, height: 38.5))
        titleView.addSubview(t1)
        t1.text = "格利商品批次"
        t1.font = UIFont.systemFont(ofSize: 13)
        t1.textAlignment = .center
        t1.textColor = UIColor(named: "标题字颜色")
       
        let t2 = UILabel(frame: CGRect(x: 111, y: 0, width: 110, height: 38.5))
        titleView.addSubview(t2)
        t2.text = "商品状态"
        t2.font = UIFont.systemFont(ofSize: 13)
        t2.textAlignment = .center
        t2.textColor = UIColor(named: "标题字颜色")
        
        let t3 = UILabel(frame: CGRect(x: t2.frame.maxX+1, y: 0, width: 181.5, height: 38.5))
        titleView.addSubview(t3)
        t3.text = "供应商"
        t3.font = UIFont.systemFont(ofSize: 13)
        t3.textAlignment = .center
        t3.textColor = UIColor(named: "标题字颜色")
        
        let t4 = UILabel(frame: CGRect(x: t3.frame.maxX+1, y: 0, width: 495 - t3.frame.maxX - 1 , height: 38.5))
        titleView.addSubview(t4)
        t4.text = "出库数量"
        t4.font = UIFont.systemFont(ofSize: 13)
        t4.textAlignment = .center
        t4.textColor = UIColor(named: "标题字颜色")
        
        let lineV = UIView(frame: CGRect(x: 0, y: titleView.frame.maxY, width: 495, height: 1))
        scrollView.addSubview(lineV)
        lineV.backgroundColor = UIColor(named: "#EDEDED")
        let bottomView = UIView(frame: CGRect(x: 0, y: titleView.frame.maxY+1, width: 495, height: scrollView.bounds.size.height-38.5))
        scrollView.addSubview(bottomView)
        bottomView.backgroundColor = UIColor(named: colorName)
        if dataArr!.count > 0 {
            for i in 0 ..< dataArr!.count {
                let model = dataArr![i]
                let view = UIView()
                bottomView.addSubview(view)
                view.snp.makeConstraints { (make) in
                    make.top.equalTo(i * 30)
                    make.height.equalTo(30)
                    make.left.right.equalTo(0)
                }
                let leftL = UILabel()
                view.addSubview(leftL)
                leftL.textAlignment = .center
                leftL.textColor = UIColor(named: "个人中心灰色字体")
                leftL.font = UIFont.systemFont(ofSize: 13)
                leftL.snp.makeConstraints { (make) in
                    make.centerX.equalTo(t1.snp_centerX)
                    make.centerY.equalTo(view.snp_centerY)
                    make.width.equalTo(100)
                }
                leftL.text = model.batch_sn

                let middleL = UILabel()
                bottomView.addSubview(middleL)
                middleL.textColor = UIColor(named: "个人中心灰色字体")
                middleL.font = UIFont.systemFont(ofSize: 13)
                middleL.textAlignment = .center
                middleL.snp.makeConstraints { (make) in
                    make.centerX.equalTo(t2.snp_centerX)
                    make.centerY.equalTo(view.snp_centerY)
                    make.width.equalTo(100)
                }
                var stauts = ""
                switch model.status {//1正常，2临期，3过期
                case 1:
                    stauts = "正常"
                    break
                case 2:
                    stauts = "临期"
                    break
                default:
                    stauts = "过期"
                    break
                }
                middleL.text = stauts

                let rightL = UILabel()
                bottomView.addSubview(rightL)
                rightL.textColor = UIColor(named: "个人中心灰色字体")
                rightL.textAlignment = .center
                rightL.font = UIFont.systemFont(ofSize: 13)
                rightL.snp.makeConstraints { (make) in
                    make.centerX.equalTo(t4.snp_centerX)
                    make.centerY.equalTo(view.snp_centerY)
                    make.width.equalTo(83.5)
                }
                rightL.text = "\(model.chuHuoLiang!)"
                
                let rightL2 = UILabel()
                bottomView.addSubview(rightL2)
                rightL2.textColor = UIColor(named: "个人中心灰色字体")
                rightL2.textAlignment = .center
                rightL2.font = UIFont.systemFont(ofSize: 13)
                rightL2.snp.makeConstraints { (make) in
                    make.centerX.equalTo(t3.snp_centerX)
                    make.centerY.equalTo(view.snp_centerY)
                    make.width.equalTo(171.5)
                }
                rightL2.text = "-"
                if model.ven_name != nil {
                    rightL2.text = model.ven_name
                }
            }
        }
        scrollView.contentSize = CGSize(width: 495.0, height: 38.5 + 30.0 * CGFloat(dataArr!.count))
        scrollView.isScrollEnabled = true
        super.layoutIfNeeded()
        
        remind_lbl.frame = CGRect(x: scrollView.frame.minX, y: scrollView.frame.maxY+7, width: 200, height: 15)
        remind_lbl.text = "*滑动查看更多信息"
        self.contentView.addSubview(remind_lbl)
        remind_lbl.font = UIFont.systemFont(ofSize: 11)
        remind_lbl.textColor = UIColor(named:"#F57575")
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
