//
//  GYS_FX_Product_ListVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/4.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Parchment

class GYS_FX_Product_ListVc: BaseViewController ,PagingViewControllerDelegate,UITableViewDelegate,UITableViewDataSource{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return centersArr.count
    }
    var selectIndex = 0
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell") as! TitleAndSelectCell
        cell.is_center_select = true
        let model = centersArr[indexPath.row]
        cell.titleLbl.text = model.shop_name
        cell.selectBtn.isSelected = false
        if shop_id == model.shop_id {
            cell.selectBtn.isSelected = true
        }
        return cell
    }
    
    var shop_id = -1
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    
    func rightBtnClick() {
        closeAction()
        let vc = GYS_FX_SearchViewController()
        vc.shop_id = shop_id
        vc.UserToken = UserToken as! String
        vc.look_type = 2
        if selectIndex == 0 {
            vc.look_type = 1
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    
    
    weak var pagingVC : PagingViewController?
    @IBOutlet weak var contentV: UIView!
    fileprivate var cities = [
        "已铺货商品",
        "可铺货商品"
    ]
    
    var viewControllers = [
        GYS_FX_Product_VC(title: "已铺货商品"),
        GYS_FX_Product_VC(title: "可铺货商品")
    ]
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "供应商分销商品管理"
        navbar.rightImg = UIImage(named: "ss_dark")
        self.view.addSubview(navbar)
        SetTopFrameView(view: contentV, btmView: self.view)
        
        let pagingViewController = PagingViewController(viewControllers: viewControllers)
        pagingViewController.indicatorColor = UIColor.init(named: "蓝色字体颜色")!
        pagingViewController.menuItemSize = .fixed(width: 0, height: 44*glscale)
        pagingViewController.font = UIFont.systemFont(ofSize: 13)
        pagingViewController.selectedFont = UIFont.systemFont(ofSize: 13)
        pagingViewController.textColor = UIColor.init(named: "灰色字体颜色")!
        pagingViewController.selectedTextColor = UIColor.init(named: "蓝色字体颜色")!
        pagingViewController.delegate = self
        pagingViewController.dataSource = self
        pagingViewController.sizeDelegate = self
        addChild(pagingViewController)
        contentV.backgroundColor = UIColor(named: "app底色")!
        contentV.addSubview(pagingViewController.view)
        contentV.constrainToEdges(pagingViewController.view)
        pagingViewController.didMove(toParent: self)
        pagingVC = pagingViewController
        // Do any additional setup after loading the view.
        
        setSelectCenterView()
        NotificationCenter.default.addObserver(self, selector: #selector(getNoti2(noti:)), name: NSNotification.Name(rawValue: "sum_goods_count"), object: nil)
        
        NotificationCenter.default.addObserver(self, selector: #selector(getNoti(noti:)), name: NSNotification.Name(rawValue: "fx_action"), object: nil)
        
    }
    
    @objc func getNoti2(noti:Notification){
        
        let sum_goods = String(describing: noti.userInfo!["sum_goods"]!)
        let sum_goods2 = String(describing: noti.userInfo!["sum_goods2"]!)
        
        var left_title = "已铺货商品"
        if sum_goods != "0" {
            left_title = "已铺货商品(" + sum_goods + ")"
        }
        
        var right_title = "可铺货商品"
        if sum_goods2 != "0" {
            right_title = "可铺货商品(" + sum_goods2 + ")"
        }
        cities = [
            left_title,
            right_title
        ]
        pagingVC?.reloadData(around: PagingIndexItem(index: selectIndex, title: cities[selectIndex]))
        
    }
    
    
    deinit {
        /// 移除通知
        NotificationCenter.default.removeObserver(self)
    }
    
    let center_title_lbl = UILabel()
    let arrow_img = UIImageView()
    let bg_view = UIView()
    var select_list_tbv_height = 0
    func setSelectCenterView(){
        
        HUD.flash(.progress)
        if centersArr.count == 0 {
            getDbtShop(["user_token":UserToken as Any]) { (data) in
                let model = data as! getDbtShopModel
                self.centersArr.removeAll()
                model.data?.forEach({ (item) in
                    self.centersArr.append(item)
                })
                if self.centersArr.count != 0 {
                    //MARK: -  限制中心选择高度
                    self.select_list_tbv_height = self.centersArr.count * 49
                    if self.select_list_tbv_height > 350 {
                        self.select_list_tbv_height = 350
                    }
                    
                    self.center_title_lbl.text = self.centersArr.first?.shop_name
                    self.arrow_img.image = UIImage(named: "down_blue")
                    if model.code == 1 {
                        HUD.hide()
                    }
                    self.shop_id = (model.data?.first?.shop_id)!
                    self.viewControllers.forEach { (vc) in
                        vc.shop_id = self.shop_id
                        vc.isUpData = false
                    }
                    let vc = self.viewControllers[self.selectIndex]
                    vc.home_list_tbv.mj_header?.beginRefreshing()
                }
                
                
            } failture: { (err) in
                
            }
        }
        
        contentV.addSubview(bg_view)
        bg_view.snp.makeConstraints { (make) in
            make.top.equalTo(50)
            make.height.equalTo(49)
            make.left.right.equalTo(0)
        }
        bg_view.backgroundColor = UIColor.white
        
        let img1 = UIImageView(image: UIImage(named: "icon_pilingzhongxin"))
        bg_view.addSubview(img1)
        img1.snp.makeConstraints { (make) in
            make.width.equalTo(19)
            make.height.equalTo(18.5)
            make.left.equalTo(15)
            make.top.equalTo(15.5)
        }
        
        bg_view.addSubview(arrow_img)
        arrow_img.image = UIImage(named: "down_blue")
        arrow_img.snp.makeConstraints { (make) in
            make.centerY.equalTo(img1.snp_centerY)
            make.right.equalTo(-15)
            make.width.equalTo(9.5)
            make.height.equalTo(4)
        }
        
        let lbl1 = UILabel()
        bg_view.addSubview(lbl1)
        lbl1.text = "选择"
        lbl1.font = UIFont.systemFont(ofSize: 13)
        lbl1.textColor = UIColor(named: "按钮渐变色下,字体颜色")
        lbl1.snp.makeConstraints { (make) in
            make.centerY.equalTo(img1.snp_centerY)
            make.right.equalTo(arrow_img.snp.left).offset(-10)
            make.width.equalTo(30)
            make.height.equalTo(15)
        }
        
        center_title_lbl.text = "请选择批零中心"
        center_title_lbl.font = UIFont.systemFont(ofSize: 13)
        center_title_lbl.textColor = UIColor(named: "标题字颜色")
        bg_view.addSubview(center_title_lbl)
        center_title_lbl.snp.makeConstraints { (make) in
            make.centerY.equalTo(img1.snp_centerY)
            make.right.equalTo(-15)
            make.left.equalTo(img1.snp_right).offset(10)
            make.height.equalTo(15)
        }
        
        let btn = UIButton()
        bg_view.addSubview(btn)
        btn.addTarget(self, action: #selector(btnAction), for: .touchUpInside)
        btn.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalTo(0)
        }
    }
    var centersArr:Array<getDbtShopDataModel> = []
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    var cover_btn:UIButton?
    var list_tableView:UITableView?
    @objc func closeAction(){
        cover_btn?.removeFromSuperview()
        cover_btn = nil
        list_tableView?.removeFromSuperview()
        list_tableView = nil
        arrow_img.image = UIImage(named: "down_blue")
    }
    
    @objc func btnAction(){
        if centersArr.count == 0 {
            return
        }
        arrow_img.image = UIImage(named: "up_blue")
        if cover_btn == nil {
            let btn = UIButton()
            contentV.addSubview(btn)
            btn.backgroundColor = UIColor(named: "标题字颜色")
            btn.alpha = 0.6
            btn.addTarget(self, action: #selector(closeAction), for: .touchUpInside)
            btn.snp.makeConstraints { (make) in
                make.top.equalTo(bg_view.snp_bottom)
                make.left.right.equalTo(0)
                make.bottom.equalTo(40)
            }
            cover_btn = btn
            
            let tbv = UITableView()
            contentV.addSubview(tbv)
            tbv.snp.makeConstraints { (make) in
                make.height.equalTo(select_list_tbv_height)
                make.top.equalTo(bg_view.snp_bottom)
                make.left.right.equalTo(0)
            }
            
            tbv.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
            tbv.delegate = self
            tbv.separatorStyle = .none
            tbv.showsVerticalScrollIndicator = false
            tbv.dataSource = self
            tbv.layer.cornerRadius = 5
            tbv.layer.maskedCorners = [CACornerMask.layerMinXMaxYCorner,CACornerMask.layerMaxXMaxYCorner]
            list_tableView = tbv
        }
        
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        //中心选择列表
        tableView.visibleCells.forEach { (item) in
            let cell = item as! TitleAndSelectCell
            cell.selectBtn.isSelected = false
        }
        let cell = tableView.cellForRow(at: indexPath) as! TitleAndSelectCell
        cell.selectBtn.isSelected = true
        
        closeAction()
        
        let model = centersArr[indexPath.row]
        center_title_lbl.text = model.shop_name
        
        self.shop_id = model.shop_id!
        self.viewControllers.forEach { (vc) in
            vc.shop_id = self.shop_id
            vc.isUpData = false
        }
        let vc = self.viewControllers[self.selectIndex]
        vc.home_list_tbv.mj_header?.beginRefreshing()
    }
    var noti_str = ""
    @objc func getNoti(noti:Notification){
        noti_str = String(describing: noti.userInfo!["intro"])
    }
    
    
    
    func pagingViewController(
        _ pagingViewController: PagingViewController,
        didScrollToItem pagingItem: PagingItem,
        startingViewController: UIViewController?,
        destinationViewController: UIViewController,
        transitionSuccessful: Bool){
        if transitionSuccessful {
            guard let item = pagingItem as? PagingIndexItem else { return}
            if selectIndex != item.index {
                selectIndex = item.index
                if noti_str != "" {
                    if noti_str.contains("铺货"){
                        let vc = viewControllers.first
                        vc?.isUpData = true
                    }else{
                        let vc = viewControllers.last
                        vc?.isUpData = true
                    }
                    noti_str = ""
                }else{
                    let vc = viewControllers[selectIndex]
                    if !vc.isUpData {
                        vc.home_list_tbv.mj_header?.beginRefreshing()
                    }
                }
            }
        }
    }
    
}

extension GYS_FX_Product_ListVc: PagingViewControllerDataSource {
    
    func pagingViewController(_ pagingViewController: PagingViewController, didSelectItem pagingItem: PagingItem) {
        guard let item = pagingItem as? PagingIndexItem else { return}
        if selectIndex != item.index {
            if noti_str != "" {
                if noti_str.contains("铺货"){
                    let vc = viewControllers.first
                    vc?.isUpData = true
                }else{
                    let vc = viewControllers.last
                    vc?.isUpData = true
                }
                noti_str = ""
            }else{
                let vc = viewControllers[selectIndex]
                if !vc.isUpData {
                    vc.home_list_tbv.mj_header?.beginRefreshing()
                }
            }
        }
        closeAction()
    }
    
    func pagingViewController(_: PagingViewController, pagingItemAt index: Int) -> PagingItem {
        return PagingIndexItem(index: index, title: cities[index])
    }
    
    func pagingViewController(_: PagingViewController, viewControllerAt index: Int) -> UIViewController {
        
        return viewControllers[index]
    }
    
    func numberOfViewControllers(in pagingViewController: PagingViewController) -> Int {
        return cities.count
    }
    
}

extension GYS_FX_Product_ListVc: PagingViewControllerSizeDelegate {
    
    
    func pagingViewController(_ pagingViewController: PagingViewController, widthForPagingItem pagingItem: PagingItem, isSelected: Bool) -> CGFloat {
        
        return ScreenWidth/2.0
    }
    
}
