//
//  GYS_FX_Product_VC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/11/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class GYS_FX_Product_VC: BaseViewController,UITableViewDelegate,UITableViewDataSource,GYS_FX_ProductCellDelegate{
    func GYS_FX_ProductCellTableViewCellSelect(idx: Int) {
    }
    
    func GYS_FX_ProductCellTableViewCellBtnAction(idx: Int) {
        let model = datas[idx]
        var action = 1
        var intro = "铺货成功~"
        if (self.title!.contains("已铺货")) {
            action = 2
            intro = "取消成功~"
        }
        
        let dic = ["user_token":UserToken as Any,
                   "sku_id":model.sku_id as Any,
                   "shop_id":shop_id as Any,
                   "action":action]
        spreadGoods(dic) { (data) in
            HUD.flash(.label(intro), delay: 0.5)
            self.home_list_tbv.mj_header?.beginRefreshing()
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "fx_action"), object: nil, userInfo: ["intro":intro])
            
        } failture: { (err) in
        }
    }
    
    @IBOutlet weak var center_select_btn: UIView!
    var page : Int = 0
    var isUpData = true{
        didSet{
            if isUpData {
                if home_list_tbv != nil {
                    home_list_tbv.mj_header?.beginRefreshing()
                }
            }
        }
    }
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var shop_id:Int = 0
    
    var datas:Array<supSpreadGoodsDataModel> = []

    
    @IBOutlet weak var home_list_tbv: UITableView!//主视图列表
    
//    var centersArr:Array<getDbtShopDataModel> = []
    
 
    
    //MARK:--VC 初始化
    convenience init(title: String) {
        self.init(title: title, content: "")
    }
    
    init(title: String, content: String) {
        super.init(nibName: nil, bundle: nil)
        self.title = title
        if title.contains("已铺货") {
            look_type = 1
        }else{
            look_type = 2
        }
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        home_list_tbv.register(UINib(nibName: "GYS_FX_ProductCellTableViewCell", bundle: nil), forCellReuseIdentifier: "GYS_FX_ProductCellTableViewCell")
        home_list_tbv.delegate = self
        home_list_tbv.separatorStyle = .none
        home_list_tbv.dataSource = self

        NotificationCenter.default.addObserver(self, selector: #selector(getNoti(noti:)), name: NSNotification.Name(rawValue: "haveChange"), object: nil)
        
        //下拉刷新相关设置
        self.headerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadData))
        self.home_list_tbv.mj_header = self.headerMJ
        //上拉加载相关设置
        
        self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadMoreData))
        self.home_list_tbv.mj_footer = self.footerMJ
    }
    deinit {
        /// 移除通知
        NotificationCenter.default.removeObserver(self)
    }
    @objc func getNoti(noti:Notification){
        home_list_tbv.mj_header?.beginRefreshing()
    }
    
    var look_type = -1
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        page = 1
        isUpData = true
 
        let dic = ["user_token":UserToken as Any,"retrieval":"" as Any,"page":page as Any,"look_type":look_type as Any,"shop_id":shop_id as Any]
        
        supSpreadGoods(dic) { (data) in
            
            let model = data  as! supSpreadGoodsModel
            self.datas.removeAll()
            model.data?.res?.forEach({ (item) in
                self.datas.append(item)
            })
            self.home_list_tbv.reloadData()
            self.home_list_tbv?.mj_header?.endRefreshing()
            self.page = 2
            
            if model.data?.sum_goods2 != nil && model.data?.sum_goods != nil{
                NotificationCenter.default.post(name: NSNotification.Name(rawValue: "sum_goods_count"), object: nil, userInfo: ["sum_goods":model.data!.sum_goods!,"sum_goods2":model.data!.sum_goods2!] )
            }
          
            if model.data?.res?.count == 0  {
                self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.home_list_tbv?.mj_footer?.endRefreshing()
            }
        } failture: { (err) in
            self.home_list_tbv?.mj_header?.endRefreshing()
        }
        
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        
        let dic = ["user_token":UserToken as Any,"retrieval":"" as Any,"page":page as Any,"look_type":look_type as Any,"shop_id":shop_id as Any]
        supSpreadGoods(dic, success: { (data) in
            let model = data  as! supSpreadGoodsModel
            if model.data?.res?.count == 0 {
                self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.res?.forEach({ (item) in
                    self.datas.append(item)
                })
                self.home_list_tbv.reloadData()
                self.home_list_tbv?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.home_list_tbv?.mj_footer?.endRefreshing()
        }
    }
    
 
    //MARK: - tableview_delegate
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
            return datas.count
        
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
 
            let cell = tableView.dequeueReusableCell(withIdentifier: "GYS_FX_ProductCellTableViewCell") as! GYS_FX_ProductCellTableViewCell
            if self.title!.contains("已铺货") {
                cell.submitBtn.setTitle("取消铺货", for: .normal)
            }else{
                cell.submitBtn.setTitle("铺货", for: .normal)
            }
            cell.tag = indexPath.row
            cell.delegate = self
            let model = datas[indexPath.row]
            cell.title_Lbl.text = model.goods_name
            if model.dbt_sale != nil {
                cell.sell_total_Lbl.text = "销量: " + StringByInt(number: model.dbt_sale!)
            }else{
                cell.sell_total_Lbl.text = "销量: -"
            }
            if model.inventory != nil {
                cell.store_lbl.text = "库存: " + StringByInt(number: model.inventory!)
            }else{
                cell.store_lbl.text = "库存: -"
            }
            if model.commission_type == 1 {
                cell.FX_Percent_Lbl.text = StringByInt(number: model.commission_per!) + "%"
                cell.FX_Percent_Lbl.isHidden = false
            }else{
                cell.FX_Percent_Lbl.isHidden = true
            }
            
            
            cell.old_price_line.isHidden = false
            cell.new_price_Lbl.isHidden = false
            if model.dbt_price == nil {
                cell.old_price_line.isHidden = true
                cell.new_price_Lbl.text = ""
            }else{
                cell.new_price_Lbl.text = "¥" + model.dbt_price!
            }
            cell.old_price_Lbl.text = model.price
            cell.item_Icon_Img.sd_setImage(with:URL(string:SERVERCE_ImageHost +  model.goods_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
            return cell
        
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 125
    }
}
