//
//  GYS_FX_SearchViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/11/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class GYS_FX_SearchViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource, UISearchBarDelegate, SearchBarViewDelegate,GYS_FX_ProductCellDelegate{
    func GYS_FX_ProductCellTableViewCellBtnAction(idx: Int) {
        let model = datas[idx]
        var action = 1
        var intro = "铺货成功~"
        if look_type == 1 {
            action = 2
            intro = "取消成功~"
        }
        let dic = ["user_token":UserToken as Any,
                   "sku_id":model.sku_id as Any,
                   "shop_id":shop_id as Any,
                   "action":action]
        spreadGoods(dic) { (data) in
            HUD.flash(.label(intro), delay: 1.2)
            self.home_list_tbv.mj_header?.beginRefreshing()
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "haveChange"), object: "gysSearch")
        } failture: { (err) in
            
        }
    }
    
    func GYS_FX_ProductCellTableViewCellSelect(idx: Int) {
        //这里没用。
    }
    
    var keyword = ""
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        if keyword.count > 0 {
            self.home_list_tbv.mj_header?.beginRefreshing()
        }
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
//        keyword = ""
//        self.home_list_tbv.mj_header?.beginRefreshing()
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
    
        removeBlackBtnView()
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                loadData()
            }
        }
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(searchView!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        blackBtnView.isUserInteractionEnabled = false

        return true
    }
    
    var isAlreadySearch = false
    
    @IBAction func backAction(_ sender: UIButton) {
        self.navigationController?.popViewController(animated: true)
    }
    @IBOutlet weak var searchView: UIView!
    weak var searchV: SearchBarView? = nil
    
    @IBOutlet weak var home_list_tbv: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        self.view.backgroundColor = UIColor.white
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.searchView.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.placeholderStr = "请输入商品名称"
        searchBr.delegate = self
        searchBr.delegateL = self
        
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        home_list_tbv.register(UINib(nibName: "GYS_FX_ProductCellTableViewCell", bundle: nil), forCellReuseIdentifier: "GYS_FX_ProductCellTableViewCell")
        home_list_tbv.delegate = self
        home_list_tbv.separatorStyle = .none
        home_list_tbv.dataSource = self
        
        //下拉刷新相关设置
        self.headerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadData))
        self.home_list_tbv.mj_header = self.headerMJ
        //上拉加载相关设置
        self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadMoreData))
        self.home_list_tbv.mj_footer = self.footerMJ
       
    }
    
    var page = 0
    var look_type = 1
    var shop_id = 0
    var UserToken = ""
    
    var datas:Array<supSpreadGoodsDataModel> = []
    
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        page = 1

        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"look_type":look_type as Any,"shop_id":shop_id as Any]
        
        supSpreadGoods(dic) { (data) in
            
            let model = data  as! supSpreadGoodsModel
            self.datas.removeAll()
            model.data?.res?.forEach({ (item) in
                self.datas.append(item)
            })
            self.home_list_tbv.reloadData()
            self.home_list_tbv?.mj_header?.endRefreshing()
            self.page = 2
            if model.data?.res?.count == 0 ||  model.data?.res != nil{
                self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.home_list_tbv?.mj_footer?.endRefreshing()
            }
        } failture: { (err) in
            self.home_list_tbv?.mj_header?.endRefreshing()
        }

    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"look_type":look_type as Any,"shop_id":shop_id as Any]
        supSpreadGoods(dic, success: { (data) in
            let model = data  as! supSpreadGoodsModel
            if model.data?.res?.count == 0 || model.data?.res == nil {
                self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.res?.forEach({ (item) in
                    self.datas.append(item)
                })
                self.home_list_tbv.reloadData()
                self.home_list_tbv?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.home_list_tbv?.mj_footer?.endRefreshing()
        }
    }
    
    
//MARK: - tableview_delegate

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "GYS_FX_ProductCellTableViewCell") as! GYS_FX_ProductCellTableViewCell
        let model = datas[indexPath.row]
        cell.delegate = self
        cell.tag = indexPath.row
        cell.title_Lbl.text = model.goods_name
        cell.sell_total_Lbl.text = "销量: -"
        if model.dbt_sale != nil {
            cell.sell_total_Lbl.text = "销量: " + StringByInt(number: model.dbt_sale!)
        }
        cell.store_lbl.text = "库存: -"
        if model.inventory != nil {
            cell.store_lbl.text = "库存: " + StringByInt(number: model.inventory!)
        }
        if model.commission_type == 1 {
            cell.FX_Percent_Lbl.text = StringByInt(number: model.commission_per!) + "%"
            cell.FX_Percent_Lbl.isHidden = false
        }else{
            cell.FX_Percent_Lbl.isHidden = true
        }
        cell.submitBtn.setTitleColor(UIColor(named: "按钮背景颜色"), for: .normal)
        if look_type == 1 {
            cell.submitBtn.setTitle("取消铺货", for: .normal)
        }else{
            cell.submitBtn.setTitle("铺货", for: .normal)
        }
        cell.old_price_line.isHidden = false
        cell.new_price_Lbl.isHidden = false
        if model.dbt_price == nil {
            cell.old_price_line.isHidden = true
            cell.new_price_Lbl.text = ""
        }else{
            cell.new_price_Lbl.text = "¥" + model.dbt_price!
        }
        if model.price != nil {
            cell.old_price_Lbl.text = "¥" + model.price!
            cell.old_price_Lbl.isHidden = false
        }else{
            cell.old_price_line.isHidden = true
            cell.old_price_Lbl.isHidden = true
        }
        cell.item_Icon_Img.sd_setImage(with:URL(string:SERVERCE_ImageHost +  model.goods_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
        return cell
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 125
    }
}
