//
//  GYS_HZ_Vc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/11/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class GYS_HZ_Vc: BaseViewController,UITableViewDelegate,UITableViewDataSource, UISearchBarDelegate, SearchBarViewDelegate,GYS_GuanLi_CellDelegate, GeliAlertViewDelegate{
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var keyword = ""
    var title_str = ""
    
    func sureGeliAlertViewAction(sender: UIButton) {
        if title_str == "分销商管理" {
            let model = dbt_datas[sender.tag]
            stopContract(["user_token":UserToken as Any,"dbt_id":model.dbt_id]) { (data) in
                HUD.flash(.label("删除成功~"), delay: 1.2)
                self.home_list_tbv.mj_header?.beginRefreshing()
            } failture: { (err) in}
            return
        }
        let model = gys_datas[sender.tag]
        stopContract(["user_token":UserToken as Any,"sup_id":model.sup_id]) { (data) in
            HUD.flash(.label("终止合作成功~"), delay: 1.2)
            self.home_list_tbv.mj_header?.beginRefreshing()
        } failture: { (err) in}
    }
    
    func GYS_GuanLi_CellStopAction(idx:Int) {
        var content = "终止和单个供应商的合作后，从该供应商处代销的所有产品都将不再能订单回流，且立即生效，是否确认终止合作？"
        if title_str == "分销商管理" {
            content = "删除该店铺后，该店铺将无法代销对应的分销产品，是否确定删除该分销商？"
        }
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = content
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        alertView.rightBtn.tag = idx
        self.view.window?.addSubview(alertView)
    }
    
    var centers:Array<getAllShopDataModel> = []
    var gys_centers:Array<getSupShopDataModel> = []
    
    var is_gys = true
    
    func loadCenterData(){
        HUD.flash(.progress)
        if is_gys {
            
            if gys_centers.count == 0 {
                    getSupShop(["user_token":UserToken as Any]) { (data) in
                        let model = data as! getSupShopModel
                        model.data?.forEach({ (item) in
                            self.gys_centers.append(item)
                        })
                        
                        HUD.hide()
                        let alertView = GLAlertTbAddView(frame: self.view.bounds)
                        alertView.is_gys = self.is_gys
                        alertView.bottom_tableview.isHidden = true
                        alertView.gys_centers = self.gys_centers
                        self.view.addSubview(alertView)
                    } failture: { (err) in
                }
            }else{
                let alertView = GLAlertTbAddView(frame: self.view.bounds)
                alertView.bottom_tableview.isHidden = true
                alertView.is_gys = self.is_gys
                alertView.gys_centers = self.gys_centers
                self.view.addSubview(alertView)
            }
            return
        }else{
            if centers.count == 0 {
                getAllShop(["user_token":UserToken as Any]) { (data) in
                        let model = data as! getAllShopModel
                        model.data?.forEach({ (item) in
                            self.centers.append(item)
                        })
                    let alertView = GLAlertTbAddView(frame: self.view.bounds)
                    alertView.bottom_tableview.isHidden = true
                    alertView.centers = self.centers
                    alertView.is_gys = self.is_gys
                    self.view.addSubview(alertView)
                        HUD.hide()
                    } failture: { (err) in
                }
            }else{
                let alertView = GLAlertTbAddView(frame: self.view.bounds)
                alertView.bottom_tableview.isHidden = true
                alertView.centers = self.centers
                alertView.is_gys = self.is_gys
                self.view.addSubview(alertView)
            }
        }
    }
    
    
    func rightBtnClick() {
        print("新增店铺")//GLAlertTbAddView
        loadCenterData()
        
    }
    
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        self.home_list_tbv.mj_header?.beginRefreshing()
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                loadData()
            }
        }
        removeBlackBtnView()
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(search_view!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    
    weak var searchV: SearchBarView? = nil
    @IBOutlet weak var search_view: UIView!
    @IBOutlet weak var home_list_tbv: UITableView!
    var gys_datas:Array<supListDataModel> = []
    var dbt_datas:Array<dbtListDataModel> = []
    override func viewDidLoad() {
        super.viewDidLoad()
        SetTopFrame(view: search_view, height: 44)
        
        navbar.title = title_str
        self.view.addSubview(navbar)
        
        let searchBr = SearchBarView.init()
        searchV = searchBr
        
        var holder_str = "请输入供应商名称"
        
        if title_str == "分销商管理" {
            navbar.rightTitle = "新增店铺"
            holder_str = "请输入分销商名称"
            is_gys = false
        }else{
            navbar.rightTitle = "新增供应商"
            is_gys = true
        }
        
        searchBr.placeholderStr = holder_str
        self.search_view.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.delegate = self
        searchBr.delegateL = self
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        home_list_tbv.register(UINib(nibName: "GYS_GuanLi_Cell", bundle: nil), forCellReuseIdentifier: "GYS_GuanLi_Cell")
        home_list_tbv.separatorStyle = .none
        // Do any additional setup after loading the view.
        
        //下拉刷新相关设置
        self.headerMJ.setRefreshingTarget(self, refreshingAction: #selector(self.loadData))
        self.home_list_tbv.mj_header = self.headerMJ
        self.home_list_tbv.mj_header?.beginRefreshing()
        
        NotificationCenter.default.addObserver(self, selector: #selector(getNoti(noti:)), name: NSNotification.Name(rawValue: "haveAdd"), object: nil)
        
        
    }
    deinit {
        /// 移除通知
        NotificationCenter.default.removeObserver(self)
    }
    
    @objc func getNoti(noti:Notification){
        home_list_tbv.mj_header?.beginRefreshing()
    }
    
    @objc func loadData(){
        if title_str == "分销商管理" {
            dbtList(["user_token":UserToken as Any,"keyword":keyword as Any]) { (data) in
                self.dbt_datas.removeAll()
                let model = data as! dbtListModel
                model.data?.forEach({ (item) in
                    self.dbt_datas.append(item)
                })
                self.home_list_tbv.reloadData()
                self.home_list_tbv?.mj_header?.endRefreshing()
                if model.data?.count == 0 {
                    self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
                }else{
                    self.home_list_tbv?.mj_footer?.endRefreshing()
                }
            } failture: { (err) in
                self.home_list_tbv?.mj_header?.endRefreshing()
            }
        }else{
            supList(["user_token":UserToken as Any,"keyword":keyword as Any]) { (data) in
                self.gys_datas.removeAll()
                let model = data as! supListModel
                model.data?.forEach({ (item) in
                    self.gys_datas.append(item)
                })
                self.home_list_tbv.reloadData()
                self.home_list_tbv?.mj_header?.endRefreshing()
                if model.data?.count == 0 {
                    self.home_list_tbv?.mj_footer?.endRefreshingWithNoMoreData()
                }else{
                    self.home_list_tbv?.mj_footer?.endRefreshing()
                }
            } failture: { (err) in
                self.home_list_tbv?.mj_header?.endRefreshing()
            }
        }
    }
    //MARK: - tableview_delegate
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if title_str == "分销商管理" {
            return dbt_datas.count
        }else{
            return gys_datas.count
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "GYS_GuanLi_Cell") as! GYS_GuanLi_Cell
        cell.delegate = self
        if title_str == "分销商管理" {
            cell.isFenXiaoShang = true
            if dbt_datas.count > 0  {
                let model = dbt_datas[indexPath.row]
                if model.shop_img_thumb != nil {
                    cell.icon_Img.sd_setImage(with:URL(string:SERVERCE_ImageHost +  model.shop_img_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                }
                cell.title_Lbl.text = "-"
                if model.create_time != nil {
                    cell.time_Lbl.text = model.create_time
                }
                cell.adr_Lbl.text = "-"
                if model.address != nil {
                    cell.adr_Lbl.text = model.address
                }
                cell.title_Lbl.text = model.shop_name
            }
        }else{
            if gys_datas.count > 0  {
                let model = gys_datas[indexPath.row]
                if model.shop_img_thumb != nil {
                    cell.icon_Img.sd_setImage(with:URL(string:SERVERCE_ImageHost +  model.shop_img_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
                }
                cell.title_Lbl.text = "-"
                if model.create_time != nil {
                    cell.time_Lbl.text = model.create_time
                }
                cell.adr_Lbl.text = "-"
                if model.address != nil {
                    cell.adr_Lbl.text = model.address
                }
                cell.title_Lbl.text = model.shop_name
            }
        }
        cell.tag = indexPath.row
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 148
    }
}
