//
//  ADD_FXY_View.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol ADD_FXY_ViewDelegate {
    func ADD_FXY_ViewTextInput(txt:String,type:Int,view:ADD_FXY_View)
    func ADD_FXY_ViewTypeSelect(type:Int)
    func ADD_FXY_ViewFinish(name:String)
}
class ADD_FXY_View: UIView {
    var delegate:ADD_FXY_ViewDelegate?
    func setUI(){
        phoneTf.addTarget(self, action: #selector(textChange(tf:)), for: .editingChanged)
        nameTf.addTarget(self, action: #selector(textChange(tf:)), for: .editingChanged)
        nameTf.isUserInteractionEnabled = false
    }
    
    var temp = ""
//var temp2 = ""
    @objc func textChange(tf:UITextField){
        if tf == phoneTf {
            if tf.text!.count <= 11 {
                temp = tf.text!
            }
            phoneTf.text = temp
            
            delegate?.ADD_FXY_ViewTextInput(txt: temp, type: 1, view: self)
        }else{
            if phoneTf.text!.count < 11 {
                HUD.flash(.label("请输入手机号码添加分销员"), delay: 1.2)
                nameTf.text = ""
                nameTf.isUserInteractionEnabled = false
            }
//            if (tf.text!.containsEmoji)  {
//                HUD.flash(.label("请输入非表情符号"), delay: 1.2)
//                tf.text = temp2
//                return
//            }else{
//                temp2 = tf.text!
//            }
            delegate?.ADD_FXY_ViewTextInput(txt: nameTf.text!, type: 2,view:self)
        }
    }
    @IBAction func finish_action(_ sender: UIButton) {
        if sender.titleLabel?.text == "确定"{
            if phoneTf.text?.count == 0 {
                HUD.flash(.label("请输入手机号码添加分销员"), delay: 1.2)
                return
            }
            if nameTf.text?.count == 0 {
                HUD.flash(.label("请输入分销员名称"), delay: 1.2)
                return
            }
            delegate?.ADD_FXY_ViewFinish(name: nameTf.text!)
        }else{
            self.removeFromSuperview()
        }
    }
    @IBAction func select_action(_ sender: UIButton) {
        var type = 0
        if sender == left_btn {
            left_btn.isSelected = true
            right_btn.isSelected = false
            type = 0
        }else{
            left_btn.isSelected = false
            right_btn.isSelected = true
            type = 1
        }
        delegate?.ADD_FXY_ViewTypeSelect(type: type)
    }
    @IBOutlet weak var right_btn: UIButton!
    @IBOutlet weak var left_btn: UIButton!
    @IBAction func close_action(_ sender: Any) {
        self.removeFromSuperview()
    }
    @IBOutlet weak var phoneTf: UITextField!
    @IBOutlet weak var nameTf: UITextField!
    var contentView:UIView!
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
