//
//  FXSY_Detail_ViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/29.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class FXSY_Detail_ViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return titles.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
        cell.nameLbl.text = titles[indexPath.row]
        cell.btmLine.isHidden = true
        switch title_lbl.text {
        case "订单收益":
            switch indexPath.row {
            case 0:
                cell.contentLbl.text = model?.data?.order_sn
                break
            case 1:
                cell.contentLbl.text = model?.data!.collection_name
                break
            default:
                cell.contentLbl.text = (model?.data?.supplier_time)!
                break
            }
            break
        case "订单退款":
            switch indexPath.row {
            case 0:
                cell.contentLbl.text = model?.data?.order_sn
                break
            case 1:
                cell.contentLbl.text = model?.data?.supplier_time
                break
            default:
                cell.contentLbl.text = model?.data?.refund_cycle
                break
            }
            
            break
        default:
            switch indexPath.row {
            case 0:
                cell.contentLbl.text = model?.data!.collection_account
                break
            case 1:
                cell.contentLbl.text = model?.data!.collection_name
                break
            case 2:
                cell.contentLbl.text = (model?.data?.collection_time)!
                break
            case 3:
                cell.contentLbl.text = model?.data!.supplier_account
                break
            case 4:
                cell.contentLbl.text = model?.data?.supplier_name
                break
            default:
                cell.contentLbl.text = (model?.data?.supplier_time)!
                break
            }
            break
        }
        if cell.contentLbl.text?.count == 0 {
            cell.contentLbl.text = "-"
        }
        return cell
    }
    
    @IBOutlet weak var top_view: UIView!
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var record_sn = ""
    @IBOutlet weak var list_view: UITableView!
    @IBOutlet weak var number_lbl: UILabel!
    @IBOutlet weak var title_lbl: UILabel!
    var model:incomeDetailsModel?
    var titles:Array<String> = []
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "收益详情"
        self.view.addSubview(navbar)
        SetTopFrame(view: top_view, height: 106)
        list_view.isScrollEnabled = false
        list_view.separatorStyle = .none
        HUD.show(.progress)
        list_view.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        incomeDetails(["user_token":UserToken as Any,"record_sn":record_sn as Any]) { (data) in
            HUD.hide()
            self.model = data as! incomeDetailsModel
            self.title_lbl.text = self.model!.data?.remark
            self.number_lbl.text = self.model!.data?.in_amount
            switch self.model!.data?.remark {
            case "订单收益":
                self.titles = ["订单编号","付款用户","到账时间"]
                break
            case "订单退款":
                self.titles = ["订单编号","到账时间","退款周期"]
                break
            default:
                self.titles = ["转账账户","转账账户名称","转账时间","收款账户","收款账户名称","到账时间"]
                break
            }
            self.list_view.reloadData()
        } failture: { (err) in
            
        }

    }


    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */

}
