//
//  FXSY_ViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/29.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class FXSY_ViewController: BaseViewController,GLTimeSelectViewDelegate,UITableViewDelegate,UITableViewDataSource, UISearchBarDelegate, SearchBarViewDelegate, GLAlertSelectViewDelegate{
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        inc_exp_type = selectNum
        //        getData()
        gys_list.mj_header?.beginRefreshing()
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return dataArr.count
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 84
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let model = dataArr[indexPath.row]
        print(model.record_sn!)
        let vc = FXSY_Detail_ViewController()
        vc.record_sn = model.record_sn!
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "FXSY_Cell") as! FXSY_Cell
        let data = dataArr[indexPath.row]
        cell.order_id_lbl.text = "#"+(data.record_sn)!
        cell.time_lbl.text = data.add_time!
        cell.price_lbl.text = data.in_amount!
        cell.order_id_lbl2.text = data.order_sn! + "(" + data.remark! + ")"
        return cell
    }
    
    var dataArr:Array<dbtIncomeInfoDatasModel> = []
    @IBOutlet weak var top_view_h: NSLayoutConstraint!
    @IBOutlet weak var top_view: UIView!
    
    func GLTimeSelectViewClose(){arrow_img.image = UIImage(named: "down_black")}
    
    func GLTimeSelectViewSelectFinish(date: String) {
        arrow_img.image = UIImage(named: "down_black")
        if date.count == 4 {
            date_lbl.text = date + "年"
        }else if date.count > 4 && date.count <= 7 {
            let arr = date.components(separatedBy: "-")
            date_lbl.text = arr.first! + "年" + arr.last! + "月"
        }else{
            let arr = date.components(separatedBy: "-")
            date_lbl.text = arr.first! + "年" + arr[1] + "月" + arr.last! + "日"
        }
        strNowTime = date
        //        getData()
        gys_list.mj_header?.beginRefreshing()
        
    }
    
    @IBAction func date_select_action(_ sender: Any) {
        arrow_img.image = UIImage(named: "up_black")
        let vc = GLTimeSelectView(frame: self.view.bounds)
        vc.delegate = self
        vc.dateStr = strNowTime
        self.view.addSubview(vc)
    }
    
    var role_type = 1
    var inc_exp_type = 0
    var keyword = ""
    @IBAction func top_btn_click(_ sender: UIButton) {
        removeBlackBtnView()
        if sender == left_btn {
            left_btn.isSelected = true
            right_btn.isSelected = false
            self.bottom_line.snp.updateConstraints { (make) in
                make.width.equalTo(ScreenWidth*0.5)
                make.height.equalTo(3)
                make.left.equalTo(0)
                make.top.equalTo(self.left_btn.snp_bottom)
            }
            role_type = 1
        }else{
            left_btn.isSelected = false
            right_btn.isSelected = true
            role_type = 2
            self.bottom_line.snp.updateConstraints { (make) in
                make.left.width.equalTo(ScreenWidth*0.5)
                make.height.equalTo(3)
                make.top.equalTo(self.left_btn.snp_bottom)
            }
        }
        
        //        getData()
        gys_list.mj_header?.beginRefreshing()
    }
    
    
    var glSelectView:GLAlertSelectView?
    
    @IBOutlet weak var right_btn: UIButton!
    @IBOutlet weak var left_btn: UIButton!
    @IBOutlet weak var bottom_line: UIView!
    
    
    @IBAction func type_select(_ sender: Any) {
        if glSelectView == nil {
            let view = GLAlertSelectView(frame: self.view.bounds)
            view.titleLbl.text = "请选择收支类型"
            view.delegate = self
            view.dataArr = ["收入","支出"]
            view.is_center_select = true
            view.selectNum = inc_exp_type
            self.view.addSubview(view)
            glSelectView = view
        }
    }
    @IBOutlet weak var arrow_img: UIImageView!
    @IBOutlet weak var refuse_lbl: UILabel!
    @IBOutlet weak var income_lbl: UILabel!
    @IBOutlet weak var date_lbl: UILabel!
    @IBOutlet weak var search_view: UIView!
    @IBOutlet weak var gys_list: UITableView!
    //    @IBOutlet weak var fxs_list: UITableView!
    
    
    
    @IBOutlet weak var time_select_btn: UIButton!
    var blackBtnView:UIButton! = nil
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
            time_select_btn.isUserInteractionEnabled = true
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        time_select_btn.isUserInteractionEnabled = false
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(search_view!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        blackBtnView.isUserInteractionEnabled = false
        
        return true
    }
    weak var searchV: SearchBarView? = nil
    
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        if keyword.count > 0 {
            gys_list.mj_header?.beginRefreshing()
        }
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        
        removeBlackBtnView()
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                gys_list.mj_header?.beginRefreshing()
            }
        }
    }
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    var strNowTime = ""
    func getDate()->Array<Int>{
        let date = Date()
        let timeFormatter = DateFormatter()
        //日期显示格式，可按自己需求显示
        timeFormatter.dateFormat = "yyyy-MM-dd"
        strNowTime = timeFormatter.string(from: date) as String
        let dateArr = strNowTime.components(separatedBy: "-")
        let year = Int(dateArr.first!)!
        let month = Int(dateArr[1])!
        let day = Int(dateArr[2])!
        return [year,month,day]
    }
    
    var model:dbtIncomeInfoDataModel?
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "分销收益"
        self.view.addSubview(navbar)
        
        gys_list.separatorStyle = .none
        gys_list.showsVerticalScrollIndicator = false
        
        gys_list.register(UINib(nibName: "FXSY_Cell", bundle: nil), forCellReuseIdentifier: "FXSY_Cell")
        
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.search_view.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.placeholderStr = "请输入订单编号"
        searchBr.delegate = self
        searchBr.delegateL = self
        
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        
        let arr = getDate()
        date_lbl.text = "\(arr.first!)年\(arr[1])月\(arr.last!)日"
        
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        gys_list.mj_header = self.headerMJ
        gys_list.mj_header?.beginRefreshing()
        
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        gys_list.mj_footer = self.footerMJ
    }
    
    
    
    var isFirstTime = true
    var page = 0
    
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        var dic:Dictionary<String,Any>!
        var year = "0"
        var month = "0"
        var day = "0"
        if strNowTime.count == 4 {
            year = strNowTime
        }else if strNowTime.count > 4 && strNowTime.count <= 7 {
            let arr = strNowTime.components(separatedBy: "-")
            year = arr.first!
            month = arr.last!
        }else{
            let arr = strNowTime.components(separatedBy: "-")
            year = arr.first!
            month = arr[1]
            day = arr.last!
        }
        
        dic = ["user_token":UserToken as Any,
               "role_type":role_type as Any,
               "inc_exp_type":inc_exp_type as Any,
               "keyword":keyword as Any,
               "year":year as Any,
               "month":month as Any,
               "day":day as Any,
               "page":page as Any
        ]
        
        dbtIncomeInfo(dic) { (data) in
            let dateModel = data as! dbtIncomeInfoModel
            self.model = dateModel.data
            
            if self.model?.res?.count == nil || self.model?.res?.count == 0 {
                self.gys_list?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                self.model?.res?.forEach({ (item) in
                    self.dataArr.append(item)
                })
                self.gys_list.reloadData()
                self.gys_list?.mj_footer?.endRefreshing()
            }
        } failture: { (err) in
            self.gys_list.mj_footer?.endRefreshing()
        }
    }
    
    
    @objc func loadData(){
        var dic:Dictionary<String,Any>!
        page = 1
        var year = "0"
        var month = "0"
        var day = "0"
        if strNowTime.count == 4 {
            year = strNowTime
        }else if strNowTime.count > 4 && strNowTime.count <= 7 {
            let arr = strNowTime.components(separatedBy: "-")
            year = arr.first!
            month = arr.last!
        }else{
            let arr = strNowTime.components(separatedBy: "-")
            year = arr.first!
            month = arr[1]
            day = arr.last!
        }
        
        dic = ["user_token":UserToken as Any,
               "role_type":role_type as Any,
               "inc_exp_type":inc_exp_type as Any,
               "keyword":keyword as Any,
               "year":year as Any,
               "month":month as Any,
               "day":day as Any,
               "page":page as Any
        ]
        
        dbtIncomeInfo(dic) { (data) in
            let dateModel = data as! dbtIncomeInfoModel
            self.model = dateModel.data
            if self.model?.res?.count == nil || self.model?.res?.count == 0 {
                self.gys_list.isHidden = true
                self.income_lbl.text = "收入:¥0.0"
                self.refuse_lbl.text = "支出:¥0.0"
                self.gys_list?.mj_header?.endRefreshing()
                self.gys_list?.mj_footer?.endRefreshingWithNoMoreData()
                
            }else{
                self.gys_list.isHidden = false
                if self.model?.inc != nil {
                    self.income_lbl.text = "收入:¥"+String(format: "%.02f", self.model?.inc! as! CVarArg)
                }else{
                    self.income_lbl.text = "收入:¥0.0"
                }
                
                if self.model?.exp != nil {
                    self.refuse_lbl.text = "支出:¥"+String(format: "%.02f", self.model?.exp! as! CVarArg)
                }else{
                    self.refuse_lbl.text = "支出:¥0.0"
                }
                
                self.dataArr.removeAll()
                
                
                if self.isFirstTime {
                    self.isFirstTime = false
                    if self.model?.is_dbt == 1 && self.model?.is_sup == 0 {
                        self.role_type = 2
                        self.left_btn.isSelected = false
                        self.right_btn.isSelected = true
                        self.bottom_line.snp.updateConstraints { (make) in
                            make.left.width.equalTo(ScreenWidth*0.5)
                            make.height.equalTo(3)
                            make.top.equalTo(self.left_btn.snp_bottom)
                        }
                    }
                    
                    if self.model?.is_sup == 1 && self.model?.is_dbt == 1 {
                        self.top_view.isHidden = false
                        self.bottom_line.isHidden = false
                        SetTopFrame(view: self.top_view, height: 44)
                    }else{
                        self.top_view.isHidden = true
                        SetTopFrame(view: self.top_view, height: 0.00001)
                    }
                }
                
                self.page = 2
                self.model?.res?.forEach({ (item) in
                    self.dataArr.append(item)
                })
                self.gys_list?.mj_header?.endRefreshing()
                self.gys_list.reloadData()
            }
        } failture: { (err) in
            self.gys_list.mj_header?.endRefreshing()
        }
    }
}
