//
//  S_P_K_C_Detail_Vc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/29.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class S_P_K_C_Detail_Vc: BaseViewController,UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout,UITableViewDelegate,UITableViewDataSource {
    
    var titles = ["商品格利批次号","商品状态","库存数量","仓库","库位","保质期","入库时间","商品生产日期","商品过期日期","检测报告"]
    
    var datasArr:Array<inventoryDetailsDataModel> = []
    @IBOutlet weak var topBarViewH: NSLayoutConstraint!
    @IBOutlet weak var topBarView: UIView!
    
    var selectIdx = IndexPath(item: 0, section: 0)
    var layout = UICollectionViewFlowLayout()
    var collectView:UICollectionView?
    
   
    @IBOutlet weak var list_view: UITableView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "商品库存详情"
        self.view.addSubview(navbar)
        
        if datasArr.count > 0 {
            SetTopFrame(view: topBarView, height: topBarViewH.constant)
        if collectView == nil {
            let collectionView = UICollectionView(frame: CGRect(x: 0, y: 0, width: 0, height: 0), collectionViewLayout: layout)
            collectionView.backgroundColor = UIColor.white
            collectionView.delegate = self
            collectionView.dataSource = self
            topBarView.addSubview(collectionView)
            collectionView.snp.makeConstraints { (make) in
                make.bottom.left.right.equalTo(0)
                make.height.equalTo(topBarViewH.constant)
            }
            collectionView.showsHorizontalScrollIndicator = false
            collectionView.isPagingEnabled = true
            var w:CGFloat = 0
            if datasArr.count < 5 {
                w = fullScreenWidth/CGFloat(datasArr.count)
            }else{
                w = fullScreenWidth * 0.2
            }
            layout.itemSize = CGSize(width: w, height:topBarViewH.constant)
            layout.scrollDirection = .horizontal
            collectionView.collectionViewLayout = layout
            collectionView.register(UINib(nibName: "ItemCell", bundle: nil), forCellWithReuseIdentifier: "ItemCell")
            collectView = collectionView
        }
        }else{
            SetTopFrame(view: topBarView, height: 0)
            topBarViewH.constant = 0
        }
        
        list_view.separatorStyle = .none
        list_view.showsVerticalScrollIndicator = false
        list_view.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        list_view.register(UINib(nibName: "S_P_K_C_Report_Cell", bundle: nil), forCellReuseIdentifier: "S_P_K_C_Report_Cell")
    }

    
    //MARK: - COLLECTIONVIEW DELEGATE
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 0
    }
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return datasArr.count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "ItemCell", for: indexPath)
            as! ItemCell
        cell.tag = indexPath.item
        cell.nameLbl.text = "库存" + "\(indexPath.item+1)"
        if indexPath == selectIdx {
            cell.nameLbl.textColor = UIColor(named: "蓝色字体颜色")
            cell.lineView.isHidden = false
        }else{
            cell.nameLbl.textColor = UIColor(named: "标题字颜色")
            cell.lineView.isHidden = true
        }
        return cell
        
    }
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        selectIdx = indexPath
        list_view.reloadData()
        collectionView.reloadData()
    }
    
    //MARK: - TABLEVIEWDELEGATE
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.row == 9 {
            print("查看图片")
        }
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 10
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.row == 9 {
            return 125
        }
        return 49
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let model = datasArr[selectIdx.row]
        if indexPath.row == 9 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "S_P_K_C_Report_Cell") as! S_P_K_C_Report_Cell
            cell.nameLbl.text = titles[indexPath.row]
            if model.file_url != nil {
                cell.img_view.sd_setImage(with:URL(string:SERVERCE_ImageHost + model.file_url!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
            }
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
        cell.nameLbl.text = titles[indexPath.row]
        switch indexPath.row {
        case 0:
            cell.contentLbl.text = model.batch_sn
            break
        case 1:
            cell.contentLbl.text = model.status
            break
        case 2:
            cell.contentLbl.text = StringByInt(number: model.inventory!)
            break
        case 3:
            cell.contentLbl.text = model.w_name
            break
        case 4:
            cell.contentLbl.text = model.p_name
            break
        case 5:
            cell.contentLbl.text = StringByInt(number: model.shelf_life!)
            break
        case 6:
            cell.contentLbl.text = model.add_time
            break
        case 7:
            cell.contentLbl.text = model.production_data
            break
        case 8:
            cell.contentLbl.text = model.valid_date
        default:
            break
        }
        return cell
    }
}
