//
//  KHXQ_ViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/12/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class KHXQ_ViewController: BaseViewController, TimeShowDownViewDeleagte, UISearchBarDelegate, SearchBarViewDelegate ,UITableViewDelegate,UITableViewDataSource,KHXQ_CellDelegate, GeliAlertViewDelegate{
    func sureGeliAlertViewAction(sender: UIButton) {
        let model = dataArr[sender.tag]
        let dic = [
            "user_token":UserToken as Any,
            "user_id":model.user_id as Any,
            "type_id":model.type_id as Any
        ]
        
        deleteDbtCustomer(dic) { (data) in

            HUD.flash(.label("客户删除成功"), delay: 1.2)
          
            self.tableView.mj_header?.beginRefreshing()
        } failture: { (err) in

        }

    }
    func KHXQ_Cell_Cancel_Contract(num: Int) {
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        let model = dataArr[num]
        alertView.titileLbl.text = "是否确定删除该“" + model.customer_name! + "”客户，删除后该客户信息无法找回。"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        alertView.rightBtn.tag = num
        self.view.window?.addSubview(alertView)
    }
    
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return dataArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "KHXQ_Cell") as! KHXQ_Cell
        cell.tag = indexPath.row
        let model = dataArr[indexPath.row]
        cell.name_lbl.text = model.customer_name
        cell.invite_peron_lbl.text = model.distributor_name
        cell.invite_time_lbl.text = model.create_time
        if model.order_number != nil && model.sum_order_money != nil {
            cell.orders_lbl.text = model.order_number! + "（累计成交金额" + model.sum_order_money! + "元）"
        }else{
            cell.orders_lbl.text = "-"
        }
        if model.latest_order_time == nil{
            cell.order_time_lbl.text = "-"
        }else{
            cell.order_time_lbl.text = model.latest_order_time            
        }
        cell.delegate = self
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 188
    }
    //MARK: - time select
    func TimeShowDownViewSelectMoreDate(beginDate: Date?, endginDate: Date?) {
        if beginDate == nil {
            startTime = 0
            endTime = 0
        }else{
            let timeInterval:TimeInterval = beginDate!.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = endginDate!.timeIntervalSince1970
            
            startTime = Int(timeInterval)
            endTime = Int(timeIntervalEnd)
        }
        //刷新
        tableView.mj_header?.beginRefreshing()
    }
    
    func TimeShowDownViewRemoveForSup() {
        
    }
    
    weak var timeShowDView: TimeShowDownView! = nil
    var startTime :Int? = 0
    var endTime :Int? = 0
    //MARK: - search
    var blackBtnView:UIButton! = nil
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        if timeShowDView != nil {
            timeShowDView.removeFromSuperview()
        }
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(search_view!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        blackBtnView.isUserInteractionEnabled = false
        
        return true
    }
    weak var searchV: SearchBarView? = nil
    var keyword = ""
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        removeBlackBtnView()
        if keyword.count > 0 {

            tableView.mj_header?.beginRefreshing()
        }
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
    
        removeBlackBtnView()
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                
                tableView.mj_header?.beginRefreshing()
            }
        }
    }
    
    @IBOutlet weak var tableView: UITableView!
    @IBOutlet weak var top_view: UIView!
    
   
    @IBAction func date_select_action(_ sender: Any) {
        removeBlackBtnView()
        if timeShowDView != nil {
            timeShowDView.removeFromSuperview()
            timeShowDView = nil
        }else{
            let timeShowDownView = TimeShowDownView()
            self.view.addSubview(timeShowDownView)
            timeShowDownView.snp.makeConstraints { (make) in
                make.left.right.bottom.equalToSuperview()
                make.top.equalTo(top_view.snp_bottom)
            }
            timeShowDView = timeShowDownView
            timeShowDownView.delegate = self
            if startTime != 0 {
                var time = TimeInterval(exactly: startTime!)
                timeShowDownView.BeginDate = Date(timeIntervalSince1970: time!)
                time = TimeInterval(exactly: endTime!)
                timeShowDownView.EndDate = Date(timeIntervalSince1970: time!)
                timeShowDownView.setOld()
            }
        }
    }
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var search_view: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "客户详情"
        self.view.addSubview(navbar)
        SetTopFrame(view: top_view, height: 46)
        // Do any additional setup after loading the view.
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.search_view.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.placeholderStr = "请输入分销员名称/客户名称/手机号码"
        searchBr.delegate = self
        searchBr.delegateL = self
        
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        tableView.separatorStyle = .none
        tableView.showsVerticalScrollIndicator = false
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        tableView.mj_header = self.headerMJ
        tableView.mj_header?.beginRefreshing()
        
        self.footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        tableView.mj_footer = self.footerMJ
        
        tableView.register(UINib(nibName: "KHXQ_Cell", bundle: nil), forCellReuseIdentifier: "KHXQ_Cell")
    }

    var page : Int = 0
    var isUpData = false
    var dataArr:Array<dbtCustomerInfoDataModel> = []
    @objc func loadData(){
        page = 1
        isUpData = true
        
        let dic = ["user_token":UserToken as Any,
                   "keyword":keyword as Any,
                   "start_time":startTime as Any,
                   "end_time":endTime as Any,
                   "page":page as Any
        ]
        
        dbtCustomerInfo(dic) { (data) in
            self.dataArr.removeAll()
            let model = data as! dbtCustomerInfoModel
            model.data?.forEach({ (item) in
                self.dataArr.append(item)
            })
            self.tableView.reloadData()
            self.tableView?.mj_header?.endRefreshing()
            self.page = 2
            
            if model.data?.count == nil || model.data?.count == 0 {
                self.tableView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.tableView?.mj_footer?.endRefreshing()
            }
        } failture: { (err) in
            self.tableView?.mj_header?.endRefreshing()
        }
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let dic = ["user_token":UserToken as Any,
                   "keyword":keyword as Any,
                   "start_time":startTime as Any,
                   "end_time":endTime as Any,
                   "page":page as Any
        ]
        dbtCustomerInfo(dic, success: { (data) in
            let model = data  as! dbtCustomerInfoModel
            if model.data?.count == nil || model.data?.count == 0 {
                self.tableView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.forEach({ (item) in
                    self.dataArr.append(item)
                })
              
                self.tableView.reloadData()
                self.tableView?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.tableView?.mj_footer?.endRefreshing()
        }
    }

}
