//
//  DZSHViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/13.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class DZSHViewController: BaseViewController, UITableViewDelegate, UITableViewDataSource, DZSH_Detail_ViewController_Delegate {
    func DZSH_Detail_ViewController_refresh() {
        listView.mj_header?.beginRefreshing()
    }
    
    
    //MARK: - 跳转详情
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let model = dataArr[indexPath.row]
        let vc = DZSH_Detail_ViewController()
        vc.delegate = self
        vc.title_str = "信息审核"
        vc.type = type!
        vc.action = model.vendor_audit_status!
        vc.shop_id = model.shop_id!
        vc.user_token = UserToken as! String
        self.navigationController?.pushViewController(vc, animated: true)
    }
    //MARK: - tableview_delegate
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 178.5
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return dataArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "DZSHCell") as! DZSHCell
        cell.tag = indexPath.row
        let model = dataArr[indexPath.row]
        if type == 2 {
            cell.resultImg.isHidden = false
            cell.action_btn.setTitle("查看", for: .normal)
            if model.vendor_audit_status != 2 {
                cell.resultImg.image = UIImage(named: "passImg")
                if model.vendor_audit_status == 3 {
                    cell.action_btn.setTitle("补齐资料", for: .normal)
                }
            }else{
                cell.resultImg.image = UIImage(named: "nonPassImg")
            }
        }else{
            cell.resultImg.isHidden = true
            cell.action_btn.setTitle("审核", for: .normal)
        }
        cell.action_btn.isUserInteractionEnabled = false
        cell.name_lbl.text = "-"
        if model.phone != nil && model.user_name != nil {
            cell.name_lbl.text = model.user_name! + " " + model.phone!
        }else{
            if model.user_name != nil {
                cell.name_lbl.text = model.user_name!
            }
            if model.phone != nil {
                cell.name_lbl.text = model.phone!
            }
        }
        cell.from_lbl.text = model.from
        cell.date_lbl.text = model.create_time
        return cell
    }
    
    @IBOutlet weak var listView: UITableView!
    var keyword = ""
    var isUpData = false{
        didSet{
            if !isUpData {
                if listView  != nil {
                    listView.mj_header?.beginRefreshing()
                }
            }
        }
    }
    
    @IBOutlet weak var top_btn_view: UIView!
    @IBOutlet weak var searchV: UIView!
    var page : Int = 0
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var startTime :Int? = 0
    var endTime :Int? = 0
    var type :Int? = 0 //1为待审核列表查询，2为已审核列表查询
    var from = 100 //来源：1:小程序,2:格利食品网,100全部
    var audit_type = 0 //审核类型 1审核通过 2审核不通过 3审核通过待补齐资料 100全部
    
    
    //MARK:--VC 初始化
    convenience init(title: String) {
        self.init(title: title, content: "")
    }
    init(title: String, content: String) {
        super.init(nibName: nil, bundle: nil)
        self.title = title
     
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    override func viewDidLoad() {
        super.viewDidLoad()

        listView.register(UINib(nibName: "DZSHCell", bundle: nil), forCellReuseIdentifier: "DZSHCell")
        listView.separatorStyle = .none
        listView.delegate = self
        listView.dataSource = self
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        listView.mj_header = headerMJ
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        listView.mj_footer = footerMJ
        listView.mj_header?.beginRefreshing()
    }
   
    //MARK:--loadData
    //MARK:--列表数据源
    var dataArr:Array<queryStoreListInfoData_model> = []
//    var dataArr2:Array<dbtOrderLisDataModel> = []
    @objc func loadData(){
        isUpData = true
        page = 1
        if audit_type == 0 {
            audit_type = 100
        }
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword,"page":page,"start_time":startTime as Any,"end_time":endTime as Any,"from":from as Any,"audit_type":audit_type as Any,"type":type as Any]
      
        queryStoreListInfo(dic) { (data) in
            let dataM = data as! queryStoreListInfo_model
            
            self.dataArr.removeAll()
            dataM.data?.forEach({ (model) in
                self.dataArr.append(model)
            })
            self.listView.mj_header?.endRefreshing()

            self.listView.reloadData()
             if dataM.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.listView.mj_footer?.endRefreshing()
            }
            self.page = 2
   
        } failture: { (error) in
            self.listView.mj_header?.endRefreshing()
        }
    }
    @objc func loadMoreData(){
        let dic = ["user_token":UserToken as Any,"keyword":keyword,"page":page,"start_time":startTime as Any,"end_time":endTime as Any,"from":from as Any,"audit_type":audit_type as Any,"type":type as Any]
        
        queryStoreListInfo(dic) { (data) in
            let dataM = data as! queryStoreListInfo_model
            if dataM.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.dataArr.append(model)
                })
                self.listView.reloadData()
                self.listView.mj_footer?.endRefreshing()
            }



        } failture: { (error) in
            self.listView.mj_footer?.endRefreshing()

        }
    }

}
