//
//  DZSH_Mg_ViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/13.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import Parchment

class DZSH_Mg_ViewController: BaseViewController ,PagingViewControllerDelegate, UISearchBarDelegate, SearchBarViewDelegate ,HeaderSelectViewDelegate ,SelectContentViewDelegate,TimeShowDownViewDeleagte{
    
    
    
    @IBOutlet weak var contentV: UIView!
    fileprivate let cities = [
        "待审核列表",
        "已审核列表"
    ]
    var selectIndex = 0
    let viewControllers = [
        DZSHViewController(title: "待审核列表"),
        DZSHViewController(title: "已审核列表")
    ]
    //头部滚动视图
    weak var pagingVC : PagingViewController?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "待审核店长"
        navbar.lineView.isHidden = true
        self.view.addSubview(navbar)
        SetTopFrameView(view: contentV, btmView: self.view)
        viewControllers.first?.type = 1
        viewControllers.last?.type = 2
        let pagingViewController = PagingViewController(viewControllers: viewControllers)
        pagingViewController.indicatorColor = UIColor.init(named: "蓝色字体颜色")!
        pagingViewController.menuItemSize = .fixed(width: 0, height: 44*glscale)
        pagingViewController.font = UIFont.systemFont(ofSize: 13)
        pagingViewController.selectedFont = UIFont.systemFont(ofSize: 13)
        pagingViewController.textColor = UIColor.init(named: "灰色字体颜色")!
        pagingViewController.selectedTextColor = UIColor.init(named: "蓝色字体颜色")!
        pagingViewController.delegate = self
        pagingViewController.dataSource = self
        pagingViewController.sizeDelegate = self
        addChild(pagingViewController)
        contentV.addSubview(pagingViewController.view)
        contentV.backgroundColor = UIColor(named: "app底色")!
        contentV.constrainToEdges(pagingViewController.view)
        pagingViewController.didMove(toParent: self)
        pagingVC = pagingViewController
        
        initSearchBar()
        initHeaderSelectView(idx: 1)
    }
    weak var searchV: SearchBarView? = nil
    var blackBtnView:UIButton! = nil
    var keyword = ""
    let SearchBarContentV = UIView()
    
    func initSearchBar() {
        SearchBarContentV.backgroundColor = UIColor.white
        contentV.addSubview(SearchBarContentV)
        SearchBarContentV.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.top.equalTo(50)
            make.height.equalTo(45)
        }
        let searchBr = SearchBarView.init()
        SearchBarContentV.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchV = searchBr
        searchBr.placeholderStr = "请输入申请人名称/手机号"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
    }
    func clearSearchAction() {
        
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyword.count != 0{
            keyword = searchBar.text!
            viewControllers.forEach { (vc) in
                vc.keyword = keyword
                vc.isUpData = false
            }
            let vc = viewControllers[selectIndex]
            vc.listView.mj_header?.beginRefreshing()
        }
    }
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        viewControllers.forEach { (vc) in
            vc.keyword = keyword
            vc.isUpData = false
        }
        let vc = viewControllers[selectIndex]
        vc.listView.mj_header?.beginRefreshing()
        
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        if showSelectV != nil {
            showSelectV.removeFromSuperview()
            selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
        }
        if timeShowDView != nil {
            timeShowDView.removeFromSuperview()
            selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
        }
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(SearchBarContentV.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    //MARK:--HeaderSelectView
    let changeBgView = UIView()
    
    weak var selectV: HeaderSelectView! = nil
    var showSelectvIndex = 0
    var selectIndexArr = [-1,-1,-1]
    weak var showSelectV: SelectContentView! = nil
    weak var timeShowDView: TimeShowDownView! = nil
    var startTime :Int? = 0
    var endTime :Int? = 0
    func initHeaderSelectView(idx:Int) {
        let selectView = HeaderSelectView()
        contentV.addSubview(changeBgView)
        changeBgView.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.top.equalTo(SearchBarContentV.snp_bottom)
            make.height.equalTo(45)
        }
        if selectV == nil {
            selectView.firstBtn.setTitle("申请途径", for: .normal)
            selectView.secBtn.setTitle("申请时间", for: .normal)
            if idx == 1 {
                selectView.thereBtn.removeFromSuperview()
                selectView.firstBtn.snp_makeConstraints { (make) in
                    make.left.top.bottom.equalTo(0)
                    make.width.equalTo(fullScreenWidth*0.5)
                }
                selectView.secBtn.snp_makeConstraints { (make) in
                    make.right.top.bottom.equalTo(0)
                    make.width.equalTo(fullScreenWidth*0.5)
                }
            }else{
                selectView.thereBtn.setTitle("申请类型", for: .normal)
            }
            changeBgView.addSubview(selectView)
            selectView.snp.makeConstraints { (make) in
                make.left.top.right.bottom.equalTo(0);
            }
            selectView.delegate = self
            selectV = selectView
            
            if selectIndexArr.first != -1 {
                let arr1 = ["全部", "小程序", "格利食品网"]
                selectV.firstBtn.setTitle(arr1[selectIndexArr.first!], for: .normal)
            }
            if selectIndexArr.last != -1  && idx == 0{
                let arr1 = ["全部", "审核通过", "审核未通过","审核通过待补齐资料"]
                selectV.thereBtn.setTitle(arr1[selectIndexArr.last!], for: .normal)
            }
        }
    }
    //MARK:--下拉视图模块
    func showAction(sender: Int) {
        showSelectvIndex = sender
        switch sender {
        case 0:
            do {
                let showSelectView = SelectContentView()
                showSelectView.delegate = self
                showSelectView.tag = 1
                self.view.addSubview(showSelectView)
                showSelectView.snp.makeConstraints { (make) in
                    make.left.right.bottom.equalToSuperview()
                    make.top.equalTo(changeBgView.snp_bottom)
                }
                showSelectV = showSelectView
                showSelectView.dataArr = ["全部","小程序", "格利食品网"]
                showSelectView.selectIndx = selectIndexArr[0]
                
            }
            break
        case 1:
            do {
                //选择时间
                let timeShowDownView = TimeShowDownView()
                self.view.addSubview(timeShowDownView)
                timeShowDownView.snp.makeConstraints { (make) in
                    make.left.right.bottom.equalToSuperview()
                    make.top.equalTo(changeBgView.snp_bottom)
                }
                timeShowDView = timeShowDownView
                timeShowDownView.delegate = self
                if startTime != 0 {
                    var time = TimeInterval(exactly: startTime!)
                    timeShowDownView.BeginDate = Date(timeIntervalSince1970: time!)
                    time = TimeInterval(exactly: endTime!)
                    timeShowDownView.EndDate = Date(timeIntervalSince1970: time!)
                    timeShowDownView.setOld()
                }
            }
            break
        case 2:
            do {
                let showSelectView = SelectContentView()
                showSelectView.delegate = self
                showSelectView.tag = 2
                self.view.addSubview(showSelectView)
                showSelectView.snp.makeConstraints { (make) in
                    make.left.right.bottom.equalToSuperview()
                    make.top.equalTo(changeBgView.snp_bottom)
                }
                showSelectV = showSelectView
                showSelectView.dataArr = ["全部","审核通过", "审核未通过","审核通过待补齐资料"]
                showSelectView.selectIndx = selectIndexArr[2]
            }
            break
        default: break
        }
    }
    
    func colseAction(sender: Int) {
        if showSelectV != nil {
            showSelectV.removeFromSuperview()
        }
        if timeShowDView != nil {
            timeShowDView.removeFromSuperview()
        }
    }
    
    //MARK:--SelectContentViewDelegate
    func didselectCell(sender: Int, SelectContentView: SelectContentView) {
        
        selectIndexArr[showSelectvIndex] = sender
        var arr:[String] = []
        if showSelectvIndex == 0 {
            let arr1 = ["全部", "小程序", "格利食品网"]
            arr.append(arr1[sender])
        }else if showSelectvIndex == 2{
            let arr1 = ["全部", "审核通过", "审核未通过","审核通过待补齐资料"]
            arr.append(arr1[sender])
        }
        
        viewControllers.forEach { (vc) in
            
            if selectIndexArr.first != -1 {
                var from = selectIndexArr.first!
                if from == 0 {
                    from = 100
                }
                vc.from = from
            }
            if selectIndexArr.last != -1 {
                vc.audit_type = selectIndexArr.last!
            }
            vc.isUpData = false
        }
        
        selectV.colseBytitleArr(arr: arr, index:showSelectvIndex)
        
        viewControllers.forEach { (vc) in
            vc.isUpData = false
        }
        let vc = viewControllers[selectIndex]
        vc.listView.mj_header?.beginRefreshing()
        
    }
    
    
    
    func selectContentvRemoveForSup() {
        selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
    }
    //MARK:--TimeShowDownViewDeleagte
    func TimeShowDownViewRemoveForSup() {
        selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
    }
    func TimeShowDownViewSelectMoreDate(beginDate: Date?, endginDate: Date?) {
        if beginDate == nil {
            startTime = 0
            endTime = 0
        }else{
            let timeInterval:TimeInterval = beginDate!.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = endginDate!.timeIntervalSince1970
            
            startTime = Int(timeInterval)
            endTime = Int(timeIntervalEnd)
        }
        viewControllers.forEach { (vc) in
            vc.startTime = startTime
            vc.endTime = endTime
            vc.isUpData = false
        }
        let vc = viewControllers[selectIndex]
        vc.listView.mj_header?.beginRefreshing()
        
    }
    
    //MARK:---滚动选择
    
    func pagingViewController(_ pagingViewController: PagingViewController, didScrollToItem pagingItem: PagingItem, startingViewController: UIViewController?, destinationViewController: UIViewController, transitionSuccessful: Bool) {
        guard let item = pagingItem as? PagingIndexItem else { return}
        print(selectIndex)
        selectV.removeFromSuperview()
        selectV = nil
        initHeaderSelectView(idx: selectIndex)
        
        if selectIndex != item.index {
            selectIndex = item.index
            let vc = viewControllers[selectIndex]
            if !vc.isUpData {
                vc.listView.mj_header?.beginRefreshing()
            }
            if showSelectV != nil {
                showSelectV.removeFromSuperview()
                selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
            }
            if timeShowDView != nil {
                timeShowDView.removeFromSuperview()
                selectV.colseBytitleArr(arr: [], index:showSelectvIndex)
            }
        }
    }
}
extension DZSH_Mg_ViewController: PagingViewControllerDataSource {
    
    func pagingViewController(_: PagingViewController, pagingItemAt index: Int) -> PagingItem {
        return PagingIndexItem(index: index, title: cities[index])
    }
    
    func pagingViewController(_: PagingViewController, viewControllerAt index: Int) -> UIViewController {
        return viewControllers[index]
    }
    
    func numberOfViewControllers(in pagingViewController: PagingViewController) -> Int {
        return cities.count
    }
    
}

extension DZSH_Mg_ViewController: PagingViewControllerSizeDelegate {
    
    
    func pagingViewController(_ pagingViewController: PagingViewController, widthForPagingItem pagingItem: PagingItem, isSelected: Bool) -> CGFloat {
        
        return ScreenWidth/2.0
    }
    
}
