//
//  OnlyTimeSelectView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/18.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import LGButton
protocol OnlyTimeSelectView_Delegate {
    func OnlyTimeSelectView_submitAction(view:OnlyTimeSelectView,sh:Int,sm:Int,eh:Int,em:Int)
}
class OnlyTimeSelectView: UIView,UIPickerViewDelegate,UIPickerViewDataSource {
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 2
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if component == 0 {
            return hourArr.count
        }
        return minArr.count
    }
    //设置选择框各选项的内容，继承于UIPickerViewDelegate协议
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int,
                    forComponent component: Int) -> String? {
        
        if component == 0 {
            return hourArr[row]
        }
        return minArr[row]
    }
    
    var titleStr = "" {
        didSet{
            let arr = titleStr.components(separatedBy: "-")
            let startArr = arr.first?.components(separatedBy: ":") as! Array<NSString>
            start_hour = startArr.first!.integerValue
            start_min = startArr.last!.integerValue
            temp_s_h = start_hour
            temp_s_m = start_min
            
            let endArr = arr.last?.components(separatedBy: ":") as! Array<NSString>
            end_hour = endArr.first!.integerValue
            end_min = endArr.last!.integerValue
            temp_e_h = end_hour
            temp_e_m = end_min
            
            lieft_pick.selectRow(start_hour, inComponent: 0, animated: false)
            lieft_pick.selectRow(start_min, inComponent: 1, animated: false)
            right_pick.selectRow(end_hour, inComponent: 0, animated: false)
            right_pick.selectRow(end_min, inComponent: 1, animated: false)
        }
    }
    
    var start_hour = 0
    var start_min = 0
    
    var end_hour = 0
    var end_min = 0
    
    var temp_s_h = 0
    var temp_s_m = 0
    
    var temp_e_h = 0
    var temp_e_m = 0
    
    //选中项改变事件（将在滑动停止后触发）
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int,
                    inComponent component: Int) {
        
        if component == 0 {
            if pickerView == lieft_pick {
                start_hour = row
            }else{
                end_hour = row
            }
        }else{
            if pickerView == lieft_pick {
                start_min = row
            }else{
                end_min = row
            }
        }
    }
    
    //自定义UIPickerView
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        
        
        let genderLbl = UILabel()
        genderLbl.textAlignment = .center
        genderLbl.font = UIFont.systemFont(ofSize: 15)
        genderLbl.textColor = UIColor.init(named: "标题字颜色")
        
        if component == 0 {
            genderLbl.text = hourArr[row]
        }else{
            genderLbl.text = minArr[row]
        }
        
        return genderLbl
    }
    var contentView:UIView!
    @IBOutlet weak var lieft_pick: UIPickerView!
    @IBOutlet weak var right_pick: UIPickerView!
    var delegate:OnlyTimeSelectView_Delegate?
    @IBAction func closet_action(_ sender: Any) {
        delegate?.OnlyTimeSelectView_submitAction(view: self, sh: temp_s_h, sm: temp_s_m, eh: temp_e_h, em: temp_e_m)
    }
    @IBAction func submit_action(_ sender: Any) {
        delegate?.OnlyTimeSelectView_submitAction(view: self, sh: start_hour, sm: start_min, eh: end_hour, em: end_min)
        
    }
    
    var hourArr:Array<String> = []
    var minArr:Array<String> = []
    func setUI(){
        for i in 0 ..< 24 {
            if i < 10 {
                let num = "0" + StringByInt(number: i)
                hourArr.append(num)
            }else{
                hourArr.append(StringByInt(number: i))
            }
        }
        for i in 0 ..< 60 {
            if i < 10 {
                let num = "0" + StringByInt(number: i)
                minArr.append(num)
            }else{
                minArr.append(StringByInt(number: i))
            }
        }
   
        
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}
