//
//  DZGL_VC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/3/19.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class DZGL_VC: BaseViewController, UITableViewDelegate, UITableViewDataSource, UISearchBarDelegate, SearchBarViewDelegate ,DZGL_Cell_Delegate,GeliAlertViewDelegate,DZSH_Detail_ViewController_Delegate {
    func DZSH_Detail_ViewController_refresh() {
        tableView.mj_header?.beginRefreshing()
    }
    
    func rightBtnClick() {
        print("新增店铺")//GLAlertTbAddView
        loadCenterData()
        
    }
    var centers:Array<getAllShopDataModel> = []
    func loadCenterData(){
        HUD.flash(.progress)
        
            if centers.count == 0 {
                getAllShop(["user_token":UserToken as Any]) { (data) in
                        let model = data as! getAllShopModel
                        model.data?.forEach({ (item) in
                            self.centers.append(item)
                        })
                    let alertView = GLAlertTbAddView(frame: self.view.bounds)
                    alertView.bottom_tableview.isHidden = true
                    alertView.centers = self.centers
                    alertView.is_gys = false
                    self.view.addSubview(alertView)
                        HUD.hide()
                    } failture: { (err) in
                }
            }else{
                let alertView = GLAlertTbAddView(frame: self.view.bounds)
                alertView.bottom_tableview.isHidden = true
                alertView.centers = self.centers
                alertView.is_gys = false
                self.view.addSubview(alertView)
            }
        }
    
    func sureGeliAlertViewAction(sender: UIButton) {
            let model = dbt_datas[sender.tag]
            stopContract(["user_token":UserToken as Any,"dbt_id":model.dbt_id]) { (data) in
                HUD.flash(.label("删除成功~"), delay: 1.2)
                self.tableView.mj_header?.beginRefreshing()
            } failture: { (err) in}
    }
    
    func DZGL_Cell_Del_Action(cell: DZGL_Cell) {
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "确定删除?"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        alertView.rightBtn.tag = cell.tag
        self.view.window?.addSubview(alertView)
    }
    
    func DZGL_Cell_Edit_Action(cell: DZGL_Cell) {
        let model = dbt_datas[cell.tag]
        let vc = DZSH_Detail_ViewController()
        vc.delegate = self
        vc.title_str = "店铺信息"
        vc.shop_id = model.dbt_id!
        vc.user_token = UserToken as! String
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if tableView.tag == 2 {
            return 44
        }
        return 220
    }
    
    @IBOutlet weak var cover_btn: UIButton!
    @IBOutlet weak var select_list: UITableView!
    
    var dbt_datas:Array<dbtListDataModel> = []
    
    @IBAction func close_action(_ sender: UIButton) {
        cover_btn.isHidden = true
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView.tag == 2 {
            return 3
        }
        return dbt_datas.count
    }
    var select_num = 0
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if tableView.tag == 2 {
            select_num = indexPath.row
            select_list.isHidden = true
            cover_btn.isHidden = true
            type_lbl.text = type_arr[select_num]
            self.tableView.mj_header?.beginRefreshing()
        }
    }
    
    let type_arr = ["全部","1对1","1对多"]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView.tag == 2 {
            var cell = tableView.dequeueReusableCell(withIdentifier: "cell")
            if cell == nil {
                cell = UITableViewCell(style: .default, reuseIdentifier: "cell")
                cell?.selectionStyle = .none
                cell?.textLabel?.font = UIFont.systemFont(ofSize:13)
            }
            cell?.textLabel?.text = type_arr[indexPath.row]
            cell?.textLabel?.textColor = UIColor.black
            return cell!
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "DZGL_Cell") as! DZGL_Cell
        cell.delegate = self
        cell.tag = indexPath.row
        let model = dbt_datas[indexPath.row]
        cell.name_lbl.text = model.shop_name
        if model.shop_img_thumb != nil {
            cell.img_view.sd_setImage(with:URL(string:SERVERCE_ImageHost + model.shop_img_thumb!), placeholderImage: nil,options:.allowInvalidSSLCertificates)
        }
        cell.adr_lbl.text = model.address
        cell.time_lbl.text = model.create_time
        var status = "一对多"
        cell.del_Btn.isHidden = false
        if model.is_shopowner == 1 {
            status = "一对一"
            cell.del_Btn.isHidden = true
        }
        cell.relation_lbl.text = status
        
        return cell
    }
    
    func clearSearchAction() {
        
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
    
        removeBlackBtnView()
        if keyword.count > 0 {
            keyword = searchBar.text!
            if keyword.count == 0 {
                tableView.mj_header?.beginRefreshing()
            }
        }
    }
    //MARK: - search
    var blackBtnView:UIButton! = nil
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.top.equalTo(search_view!.snp_bottom)
            make.left.right.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        blackBtnView.isUserInteractionEnabled = false
        
        return true
    }
    weak var searchV: SearchBarView? = nil
    @IBOutlet weak var tableView: UITableView!
    @IBAction func show_select_action(_ sender: UIButton) {
        cover_btn.isHidden = !cover_btn.isHidden
        select_list.isHidden = cover_btn.isHidden
        
    }
    @IBOutlet weak var type_lbl: UILabel!
    @IBOutlet weak var search_view: UIView!
    
    
    var page : Int = 0
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var keyword = ""
    var isUpData = false{
        didSet{
            if !isUpData {
                if tableView  != nil {
                    tableView.mj_header?.beginRefreshing()
                }
            }
        }
    }
    
    
    override func viewDidLoad() {
        super.viewDidLoad()

        navbar.title = "店长管理"
        navbar.rightTitle = "新增店铺"
        self.view.addSubview(navbar)
        SetTopFrame(view: search_view, height: 44)
        // Do any additional setup after loading the view.
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.search_view.addSubview(searchBr)
        searchV?.changecornerRadius(cornerRadius: 35*0.5)
        searchBr.placeholderStr = "请输入分销商名称"
        searchBr.delegate = self
        searchBr.delegateL = self
        
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        
        tableView.separatorStyle = .none
        tableView.showsVerticalScrollIndicator = false
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        tableView.mj_header = self.headerMJ
        tableView.mj_header?.beginRefreshing()
        
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        tableView.mj_footer = self.footerMJ
        
        tableView.register(UINib(nibName: "DZGL_Cell", bundle: nil), forCellReuseIdentifier: "DZGL_Cell")
        
        NotificationCenter.default.addObserver(self, selector: #selector(getNoti(noti:)), name: NSNotification.Name(rawValue: "haveAdd"), object: nil)
    }

    deinit {
        /// 移除通知
        NotificationCenter.default.removeObserver(self)
    }
    
    @objc func getNoti(noti:Notification){
        tableView.mj_header?.beginRefreshing()
    }
    var is_shopowner = 100
    @objc func loadData(){
        switch select_num {
        case 0:
            is_shopowner = 100
            break
        case 1:
            is_shopowner = 1
            break
        default:
            is_shopowner = 0
            break
        }
        page = 1
        isUpData = true
        dbtList(["page":page as Any,"user_token":UserToken as Any,"is_shopowner":is_shopowner as Any,"keyword":keyword as Any]) { (data) in
            self.dbt_datas.removeAll()
            let model = data as! dbtListModel
            model.data?.forEach({ (item) in
                self.dbt_datas.append(item)
            })
            self.tableView.reloadData()
            self.tableView?.mj_header?.endRefreshing()
            if model.data?.count == 0 {
                self.tableView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.tableView?.mj_footer?.endRefreshing()
            }
            self.page = 2
        } failture: { (err) in
            self.tableView?.mj_header?.endRefreshing()
        }
    }
    
    @objc func loadMoreData(){
        dbtList(["page":page as Any,"user_token":UserToken as Any,"is_shopowner":is_shopowner as Any,"keyword":keyword as Any]){ (data) in
            let dataM = data as! dbtListModel
            if dataM.data?.count == 0 {
                self.tableView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.dbt_datas.append(model)
                })
                self.tableView.reloadData()
                self.tableView.mj_footer?.endRefreshing()
            }
        } failture: { (error) in
            self.tableView.mj_footer?.endRefreshing()

        }
    }
}
