//
//  PrintViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/18.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import SwiftyJSON

class PrintViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,print_bottom_cellDelegate, UIPickerViewDataSource, UIPickerViewDelegate,GLTimeSelectViewDelegate{
    func GLTimeSelectViewSelectFinish(date: String) {
        let date_arr = date.components(separatedBy: "-")
        year = date_arr[0]
        month = date_arr[1]
        day = date_arr[2]
        list_view.reloadData()
    }
    var isNormal = false
    
    func GLTimeSelectViewClose() {
        
    }
    
    func print_bottom_cell_time_select() {
        let vc = GLTimeSelectView(frame: self.view.window!.bounds)
        vc.isOnlyDay = true
        vc.delegate = self
        vc.dateStr = year + "-" + month + "-" + day
        self.view.window?.addSubview(vc)
    }
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var order_id = 0
    var type = 1
    
    //MARK: - 地址选择
    //选择的省索引
    var provinceIndex = 0
    //选择的市索引
    var cityIndex = 0
    //选择的区（县）索引
    var areaIndex = 0
    
    
    
    //选择器
    var pickerView:UIPickerView!
    //所以地址数据集合
    var addressArray:Array<Any> = []
    var dzStr = ""
    //设置选择框的列数为3列,继承于UIPickerViewDataSource协议
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 3
    }
    
    //设置选择框的行数，继承于UIPickerViewDataSource协议
    func pickerView(_ pickerView: UIPickerView,
                    numberOfRowsInComponent component: Int) -> Int {
        if component == 0 {
            return self.addressArray.count
        } else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            return (province["city_list"]! as AnyObject).count
        } else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            if  (province["city_list"] as! NSArray).count == 0 {
                return 0
            }
            if let city = (province["city_list"] as! NSArray)[cityIndex]
                as? [String: AnyObject] {
                print(city["district_list"] as Any)
                return city["district_list"]!.count
            } else {
                return 0
            }
        }
    }
    //设置选择框各选项的内容，继承于UIPickerViewDelegate协议
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int,
                    forComponent component: Int) -> String? {
        if component == 0 {
            let rowDic = self.addressArray[row] as! Dictionary<String,Any>
            return rowDic["area_name"] as? String
        }else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[row]
                as! [String: AnyObject]
            return city["area_name"] as? String
        }else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[cityIndex]
                as! [String: AnyObject]
            let area = (city["district_list"] as! NSArray)[row] as! Dictionary<String,Any>
            return area["area_name"] as? String
        }
    }
    
    //选中项改变事件（将在滑动停止后触发）
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int,
                    inComponent component: Int) {
        //根据列、行索引判断需要改变数据的区域
        switch (component) {
        case 0:
            provinceIndex = row;
            pickerView.reloadComponent(1);
            pickerView.reloadComponent(2);
            pickerView.selectRow(cityIndex, inComponent: 1, animated: false)
            pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        case 1:
            cityIndex = row;
            pickerView.reloadComponent(2);
            pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        case 2:
            areaIndex = row;
        default:
            break;
        }
    }
    func pickerView(_ pickerView: UIPickerView, rowHeightForComponent component: Int) -> CGFloat {
        return 50
    }
    //自定义UIPickerView
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        let genderLbl = UILabel()
        genderLbl.textAlignment = .center
        genderLbl.font = UIFont.systemFont(ofSize: 15)
        genderLbl.textColor = UIColor.init(named: "标题字颜色")
        
        if component == 0 {
            let rowDic = self.addressArray[row] as! Dictionary<String,Any>
            genderLbl.text = rowDic["area_name"] as? String
        }else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[row]
                as! [String: AnyObject]
            genderLbl.text = city["area_name"] as? String
        }else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[cityIndex]
                as! [String: AnyObject]
            let area = (city["district_list"] as! NSArray)[row] as! Dictionary<String,Any>
            genderLbl.text = area["area_name"] as? String
        }
        
        return genderLbl
    }
    
    var tempProvince_select = -1//临时省id
    var tempCity_select = -1//临时市id
    var tempArea_select = -1//临时区id
    
    var isChange = false
    
    @objc func adrSelectFinish(sender:UIButton){
        
        var proName = ""
        var cityName = ""
        var areaName = ""
        cityDict["area_id"] = ""
        areaDict["area_id"] = ""
        cityDict["area_name"] = ""
        areaDict["area_name"] = ""
        
        proName = proDict["area_name"] as! String
        if (proDict["city_list"] as! NSArray).count > 0 {
            cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! [String: AnyObject]
            cityName = cityDict["area_name"] as! String
            if (cityDict["district_list"] as! NSArray).count > 0 {
                areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
                areaName = areaDict["area_name"] as! String
            }
        }
        
        if provinceIndex != tempProvince_select || cityIndex != tempCity_select || areaIndex != tempArea_select {
            isChange = true
        }else{
            isChange = false
        }
        
        
        
        var selectAdr = proName
        if cityName.count > 0 {
            selectAdr = proName + "-" + cityName
            if areaName.count > 0 {
                selectAdr = proName + "-" + cityName + "-" + areaName
            }
        }
        
        
        dzStr = selectAdr
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
        list_view.reloadData()
    }
    
    @objc func closeAction(sender:UIButton){
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
    }
    var btmView:UIView?
    var bgBtn:UIButton?
    //MARK:--地址选择器
    func showAreaSelect(view:UIView){
        //创建选择器
        
        pickerView=UIPickerView()
        //将dataSource设置成自己
        pickerView.dataSource=self
        //将delegate设置成自己
        pickerView.delegate=self
        view.addSubview(pickerView)
        pickerView.snp.makeConstraints { (make) in
            make.top.equalTo(30)
            make.left.right.bottom.equalTo(0)
        }
        pickerView.selectRow(provinceIndex, inComponent: 0, animated: false)
        pickerView(pickerView, didSelectRow: provinceIndex, inComponent: 0)
        pickerView.selectRow(cityIndex, inComponent: 1, animated: false)
        pickerView(pickerView, didSelectRow: cityIndex, inComponent: 1)
        pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        pickerView(pickerView, didSelectRow: areaIndex, inComponent: 2)
        
        
    }
    
    func print_bottom_cell_select_place_action() {
        print("地址选择")
        if bgBtn == nil {
            let btn = UIButton()
            self.view.addSubview(btn)
            btn.backgroundColor = UIColor.black
            btn.alpha = 0.4
            btn.addTarget(self, action: #selector(closeAction(sender:)), for: .touchUpInside)
            btn.snp.makeConstraints { (make) in
                make.top.right.bottom.left.equalTo(0)
            }
            bgBtn = btn
        }
        if btmView == nil {
            let view = UIView()
            view.backgroundColor = UIColor.white
            btmView = view
            self.view.addSubview(btmView!)
            btmView!.snp.makeConstraints { (make) in
                make.left.bottom.right.equalTo(0)
                make.height.equalTo(240)
            }
            showAreaSelect(view:btmView!)
            
            let rightBtn = UIButton()
            rightBtn.setTitle("确定", for: .normal)
            rightBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            rightBtn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
            rightBtn.addTarget(self, action: #selector(adrSelectFinish(sender:)), for: .touchUpInside)
            btmView?.addSubview(rightBtn)
            rightBtn.snp.makeConstraints { (make) in
                make.right.equalTo(-15)
                make.top.equalTo(10)
                make.height.equalTo(30)
                make.width.equalTo(50)
            }
            
            let leftBtn = UIButton()
            leftBtn.setTitle("取消", for: .normal)
            leftBtn.setTitleColor(UIColor(named: "多选按钮字体颜色"), for: .normal)
            leftBtn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
            leftBtn.addTarget(self, action: #selector(closeAction(sender:)), for: .touchUpInside)
            btmView?.addSubview(leftBtn)
            leftBtn.snp.makeConstraints { (make) in
                make.left.equalTo(15)
                make.top.equalTo(10)
                make.height.equalTo(30)
                make.width.equalTo(50)
            }
        }
    
    }
    
    func getIndex(){
        let path = Bundle.main.path(forResource: "address_new", ofType: "json")
        let url = URL(fileURLWithPath: path!)
        // 带throws的方法需要抛异常
        do {
            let data = try Data(contentsOf: url)
            let jsonData = JSON(data)
            print("地址文件数据",jsonData["data"])
            
            self.addressArray = jsonData["data"].arrayObject!
//            if navTitle == "编辑地址" {
                for i in 0 ..< addressArray.count {
                    let item = addressArray[i] as! Dictionary<String,Any>
                    if item["area_id"] as! Int == provinceIndex {
                        let citys = item["city_list"] as! Array<Dictionary<String,Any>>
                        if citys.count == 0 {
                            provinceIndex = i
                        }
                        for j in 0 ..< citys.count {
                            let cItem = citys[j]
                            if cItem["area_id"] as! Int == cityIndex {
                                let districts = cItem["district_list"] as! Array<Dictionary<String,Any>>
                                if districts.count == 0 {
                                    cityIndex = j
                                }
                                for k in 0 ..< districts.count{
                                    let dItem = districts[k]
                                    if dItem["area_id"] as! Int == areaIndex{
                                        print("id === ",k,dItem["area_id"],areaIndex)
                                        provinceIndex = i
                                        cityIndex = j
                                        areaIndex = k
                                        break
                                    }
                                }
                            }
                        }
                    }else{
                        provinceIndex = 0
                        cityIndex = 0
                        areaIndex = 0
                    }
                    proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
//                }
            }
        } catch let error as Error? {
            print("读取本地数据出现错误!",error as Any)
        }
    }
    
    
    //MARK: - 数据输入内容
    var FM_str = ""
    var detail_adr_str = ""
    var phone_str = ""
    var consignee_str = ""
    var order_num_str = ""
    
    var year = ""
    var month = ""
    var day = ""
    
    func print_bottom_cell_text_respose(tag: Int, text: String) {
        print(tag,text)
        switch tag {
        case 0:
            FM_str = text
            break
        case 1:
            detail_adr_str = text
            break
        case 2:
            phone_str = text
            break
        case 3:
            consignee_str = text
            break
        default:
            order_num_str = text
            break
        }
    }
  
    let userName = UserDefaults.standard.string(forKey: "userName")
    @IBOutlet weak var list_view: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        
        list_view.register(UINib(nibName: "print_top_btn_cell", bundle: nil), forCellReuseIdentifier: "print_top_btn_cell")
        list_view.register(UINib(nibName: "print_bottom_cell", bundle: nil), forCellReuseIdentifier: "print_bottom_cell")
        list_view.separatorStyle = .none
        list_view.showsVerticalScrollIndicator = false
        getIndex()
        if userName == "不二制油"{
            get_location_id()
        }
    }
    var proDict:Dictionary<String,Any>  = Dictionary()
    var cityDict:Dictionary<String,Any> = Dictionary()
    var areaDict:Dictionary<String,Any> = Dictionary()
    func get_location_id(){
        let proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
        var cityDict:Dictionary<String,Any> = Dictionary()
        var areaDict:Dictionary<String,Any> = Dictionary()
        cityDict["area_id"] = ""
        areaDict["area_id"] = ""
        
        if (proDict["city_list"] as! NSArray).count > 0 {
            cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! [String: AnyObject]
            if (cityDict["district_list"] as! NSArray).count > 0 {
                areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
            }
        }
    }
    //MARK:--VC 初始化
    convenience init(title: String) {
        self.init(title: title, content: "")
    }
    init(title: String, content: String) {
        super.init(nibName: nil, bundle: nil)
        self.title = title
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
   
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.row == 0 {
            print("预览")
            let dic = ["user_token":UserToken as Any,
                       "order_id":order_id as Any,
                       "remittance_account":FM_str as Any,
                       "province_id":proDict["area_id"] as Any,
                       "city_id":cityDict["area_id"] as Any,
                       "district_id":areaDict["area_id"] as Any,
                       "mobile":phone_str as Any,
                       "consignee":consignee_str as Any,
                       "address_str":detail_adr_str as Any,
                       "odd_numbers":order_num_str as Any,
                       "add_time_year":year as Any,
                       "add_time_month":month as Any,
                       "add_time_day":day as Any,
                       "print_type":type as Any
            ]
            
            printUrl(dic) { (data) in
                let d = data as! printUrl_Model
                let web_vc = WebViewController()
                web_vc.titleStr = "打印预览"
                web_vc.urlStr = d.data!
                self.navigationController?.pushViewController(web_vc, animated: true)
            } failture: { (err) in
                
            }
        }
    }
    
    //MARK: - tableview_delegate
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if self.title!.contains("普通"){
            return 1
        }
        return 2
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.row == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "print_top_btn_cell") as! print_top_btn_cell
            cell.isNormal = isNormal
            return cell
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "print_bottom_cell") as! print_bottom_cell
        cell.delegate = self
        if dzStr.count > 0 {
            cell.adr_lbl.text = dzStr
            cell.adr_lbl.textColor = UIColor(named: "标题字颜色")
        }
       
        cell.payer_tf.text = FM_str
        cell.adr_tf.text = detail_adr_str
        cell.phone_tf.text = phone_str
        cell.consignee_tf.text = consignee_str
        cell.order_number_tf.text = order_num_str
        cell.year_lbl.text = year
        cell.month_lbl.text = month
        cell.day_lbl.text = day
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.row == 0 {
            return 215
        }
        return 803
    }
}
