//
//  PPH_YDXQ_VC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/8.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import LGButton

class PPH_YDXQ_VC: BaseViewController,UITableViewDelegate,UITableViewDataSource, GeliAlertViewDelegate {
    func sureGeliAlertViewAction(sender: UIButton) {
        
        cancelOrder(["wb_no":wb_no as Any,"user_token":userToken as Any]) {[self] (data) in
                        HUD.hide()
                        title_lbl_h.constant = 0
                        action_btn.isHidden = true
                        HUD.flash(.label("订单取消成功!"), onView: self.view, delay: 1.2) { (result) in
                            top_img = UIImage(named: "pph_cancel")
                            status_str = "已取消"
                            list_view.reloadData()
                        }
                        NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)
                    } failture: { (err) in
                    }
    }
    
    var top_img = UIImage(named: "pph_order")
    var status_str = "派单中"
    var order_time_str = ""
    var status_type_str = "待分配"
    var id:Int = -1
    var userToken = ""
    var wb_no = ""
    var payType = "格利支付"
    @IBAction func cancel_action(_ sender: Any) {
        if btm_title_lbl.text == "取消订单" {
            
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否确认取消订单？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确认"), for: .normal)
            self.view.window?.addSubview(alertView)

        }else{
            let phone = "telprompt://" + mobile
            if UIApplication.shared.canOpenURL(URL(string: phone)!) {
                UIApplication.shared.openURL(URL(string: phone)!)
            }
        }
    }
    
    var sendArr:Array<cargoContactListData> = []
    var receiveArr:Array<cargoContactListData> = []
    var carType = "-"
    var driver = "-"
    var plan = "-"
    var order = "-"
    var cost = "-"
    var pay_time = "-"
    var mobile = "-"
    @IBOutlet weak var title_lbl_h: NSLayoutConstraint!
    @IBOutlet weak var btm_title_lbl: UILabel!
    @IBOutlet weak var action_btn: LGButton!
    @IBOutlet weak var list_view: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "运单详情"
        self.view.addSubview(navbar)
        navbar.backgroundColor = UIColor(named: "green")
        navbar.titleLbl.textColor = UIColor.white
        navbar.leftImg = UIImage(named: "idCard1")
        navbar.lineView.backgroundColor = UIColor(named: "green")
        SetTopFrameView(view: list_view, btmView: self.view)
        
        list_view.separatorStyle = .none
        list_view.register(UINib(nibName: "PPH_Detail_Cell", bundle: nil), forCellReuseIdentifier: "PPH_Detail_Cell")
        list_view.register(UINib(nibName: "PPH_XQ_Cell", bundle: nil), forCellReuseIdentifier: "PPH_XQ_Cell")
        list_view.backgroundColor = UIColor(named: "app底色")
        print("id",id)
        if id != -1 {
            orderDetails(["user_token":userToken as Any,"id":id as Any]) {[self] (data) in
                let model = data as! orderDetails_model
                let modelData = model.data
                switch modelData?.pph_info?.status {
                case 2:
                    top_img = UIImage(named: "pph_wait")
                    status_str = "待接货"
                    break
                case 3:
                    top_img = UIImage(named: "pph_logistics")
                    status_str = "待送达"
                    break
                case 4:
                    top_img = UIImage(named: "pph_complete")
                    status_str = "已送达"
                    break
                case 5:
                    top_img = UIImage(named: "pph_cancel")
                    status_str = "已取消"
                    break
                default:
                    break
                }
                order_time_str = timeStampToString(timeStamp: (modelData?.pph_info?.indate)!, outputFormatter: "yyyy-MM-dd hh:mm:ss")
                status_type_str = "拼拼货" + (modelData?.lwb_no)!
                modelData?.pph_info?.cargoContactList?.forEach({ (item) in
                    if item.type == 1 || item.type == 4 {
                        sendArr.append(item)
                    }
                    if item.type == 2 || item.type == 3 {
                        receiveArr.append(item)
                    }
                })
                
                if (modelData?.pph_info?.status)! > 3 {
                    title_lbl_h.constant = 0
                    action_btn.isHidden = true
                }else if (modelData?.pph_info?.status)! < 4 && (modelData?.pph_info?.status)! > 1{
                    btm_title_lbl.text = "联系司机"
                }
                
                carType = (modelData?.pph_info?.truckType)!
                let f = (modelData?.pph_info!.driverMobile)!.prefix(3)
                let l = (modelData?.pph_info!.driverMobile)!.suffix(3)
                mobile = (modelData?.pph_info!.driverMobile)!
                if (modelData?.pph_info?.driverName!.count)! > 0 {
                    driver = (modelData?.pph_info!.driverName)! + "(\(f)*****\(l))"
                }
                if (modelData?.sale_plat!.count)! > 0 {
                    plan = (modelData?.sale_plat)!
                }
                if (modelData?.order_sn!.count)! > 0 {
                    order = (modelData?.order_sn)!
                }
                cost = "¥\(modelData!.freight!)"
                pay_time = (modelData?.pay_time!)!
                payType = modelData!.pay_type!
                list_view.reloadData()
            } failture: { (err) in
                
            }
        }
    }
    
    //MARK: - tablevi(ew delegate
    func numberOfSections(in tableView: UITableView) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section > 1 {
            return 310
        }
        return UITableView.automaticDimension
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 2 {
            return 1
        }
        if section == 1 {
            return receiveArr.count
        }
        return sendArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section > 1 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "PPH_XQ_Cell") as! PPH_XQ_Cell
            cell.carType_lbl.text = carType
            cell.driver_lbl.text = driver
            cell.plan_lbl.text = plan
            cell.order_lbl.text = order
            cell.cost_lbl.text = cost
            cell.time_lbl.text = pay_time
            cell.pay_type_lbl.text = payType
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "PPH_Detail_Cell") as! PPH_Detail_Cell
        cell.isLast = false
        cell.top_line.isHidden = true
        cell.bottom_line.isHidden = false
        if indexPath.section == 0 {
            let model = sendArr[indexPath.row]
            cell.status_lbl.text = "装"
            cell.status_lbl.backgroundColor = UIColor(named: "green")
            if indexPath.row != 0 {
                cell.top_left_view.isHidden = true
                cell.top_right_view.isHidden = true
                cell.top_line.isHidden = false
            }
            cell.title_lbl.text = model.shopName
            cell.adr_lbl.text = model.address
            cell.conect_lbl.text = model.linkMan! + " " + model.mobile!
            cell.commend_lbl.text = model.note
        }
        if indexPath.section == 1 {
            let model = receiveArr[indexPath.row]
            cell.top_left_view.isHidden = true
            cell.top_right_view.isHidden = true
            cell.top_line.isHidden = false
            cell.status_lbl.backgroundColor = UIColor(named: "#FAA376")
            cell.status_lbl.text = "卸"
            if indexPath.row == receiveArr.count - 1 {
                cell.isLast = true
                cell.bottom_line.isHidden = true
                cell.layoutIfNeeded()
            }
            cell.title_lbl.text = model.shopName
            cell.adr_lbl.text = model.address
            cell.conect_lbl.text = model.linkMan! + " " + model.mobile!
            cell.commend_lbl.text = model.note
        }
        return cell
    }
    
    
    func setYuanJiao2(sender:UIView,radii:Int){
        let maskPath = UIBezierPath(roundedRect: sender.bounds,
                                    byRoundingCorners:[.bottomLeft, .bottomRight], cornerRadii:CGSize(width:radii, height:radii))
        let masklayer = CAShapeLayer()
        masklayer.frame = sender.bounds
        masklayer.path = maskPath.cgPath
        sender.layer.mask = masklayer
    }
    //MARK: - footerView
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 0.00001
    }
    
    //MARK: - headerView
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: ScreenWidth, height: 225))
        view.backgroundColor = UIColor(named: "app底色")
        let colorV = UIView(frame:CGRect(x: 0, y: 0, width: ScreenWidth, height: 205))
        colorV.backgroundColor = UIColor(named: "green")
        setYuanJiao2(sender: colorV,radii: 20)
        view.addSubview(colorV)
        view.layer.masksToBounds = true
        
        let img = UIImageView()
        view.addSubview(img)
        img.snp.makeConstraints { (make) in
            make.top.equalTo(35)
            make.centerX.equalTo(view.snp_centerX)
            make.width.height.equalTo(45)
        }
        img.image = top_img
        
        let lbl = UILabel()
        lbl.text = status_str
        view.addSubview(lbl)
        lbl.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.height.equalTo(17)
            make.top.equalTo(img.snp_bottom).offset(15)
        }
        lbl.font = UIFont(name: "PingFangSC-Medium", size: 17)
        lbl.textColor = UIColor.white
        lbl.textAlignment = .center
        
        let topView = UIView()
        topView.backgroundColor = UIColor.white
        view.addSubview(topView)
        topView.snp.makeConstraints { (make) in
            make.bottom.equalToSuperview()
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(101)
        }
        topView.layer.cornerRadius = 10
        topView.layer.masksToBounds = true
        
        let leftCorner = UIView()
        leftCorner.backgroundColor = UIColor(named: "app底色")
        view.addSubview(leftCorner)
        leftCorner.snp.makeConstraints { (make) in
            make.width.height.equalTo(20)
            make.left.equalTo(5)
            make.centerY.equalTo(topView.snp_bottom)
        }
        leftCorner.layer.cornerRadius = 10
        leftCorner.layer.masksToBounds = true
        
        
        let rightCorner = UIView()
        rightCorner.backgroundColor = UIColor(named: "app底色")
        view.addSubview(rightCorner)
        rightCorner.snp.makeConstraints { (make) in
            make.width.height.equalTo(20)
            make.right.equalTo(-5)
            make.centerY.equalTo(topView.snp_bottom)
        }
        rightCorner.layer.cornerRadius = 10
        rightCorner.layer.masksToBounds = true
        
        
        let timeTitle = UILabel()
        topView.addSubview(timeTitle)
        timeTitle.font = UIFont.systemFont(ofSize: 13)
        timeTitle.textColor = UIColor(named: "标题字颜色")
        timeTitle.text = "下单时间："
        timeTitle.snp.makeConstraints { (make) in
            make.top.left.equalTo(15)
        }
        
        let timeStrLbl = UILabel()
        topView.addSubview(timeStrLbl)
        timeStrLbl.font = UIFont.systemFont(ofSize: 13)
        timeStrLbl.textColor = UIColor(named: "标题字颜色")
        timeStrLbl.text = order_time_str
        timeStrLbl.snp.makeConstraints { (make) in
            make.centerY.equalTo(timeTitle.snp_centerY)
            make.right.equalTo(-15)
        }
        
        let line1 = UIView()
        topView.addSubview(line1)
        line1.backgroundColor = UIColor(named: "灰色分界线")
        line1.snp.makeConstraints { (make) in
            make.top.equalTo(timeTitle.snp_bottom).offset(15)
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.height.equalTo(1)
        }
        
        let status_lbl = UILabel()
        topView.addSubview(status_lbl)
        status_lbl.font = UIFont.systemFont(ofSize: 13)
        status_lbl.textColor = UIColor(named: "标题字颜色")
        status_lbl.text = status_type_str
        status_lbl.snp.makeConstraints { (make) in
            make.top.equalTo(line1.snp_bottom).offset(15)
            make.right.equalTo(-15)
        }
        
        let line2 = UIImageView()
        topView.addSubview(line2)
        line2.image = UIImage(named: "dotLine")
        line2.snp.makeConstraints { (make) in
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(1)
            make.bottom.equalTo(0)
        }
        return view
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 0 {
            return 225
        }
        return 0.0001
    }
}
