//
//  P_P_H_Adr_VC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/1.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import SwiftyJSON
import LGButton

protocol P_P_H_Adr_VC_Delegate {
    func P_P_H_Adr_VC_Data(adrData:addPinPinOrder_adrInfo,isSend:Bool,idx:Int)
}
class P_P_H_Adr_VC: BaseViewController,SJMapViewControllerDelegate,UITextViewDelegate {
    @IBOutlet weak var submit_btn: LGButton!
    var isSend = false
    var idx = 0
    var delegate:P_P_H_Adr_VC_Delegate?
    var lat:Double = 0
    var lng:Double = 0
    var adrInfo:addPinPinOrder_adrInfo?
    @IBOutlet weak var count_lbl: UILabel!
    @IBOutlet weak var textTV: UITextView!
    @IBOutlet weak var phoneTf: UITextField!
    @IBOutlet weak var adrTf: UITextField!
    
    @IBOutlet weak var nameTf: UITextField!
   
    var adrLast = ""
    func SJMapViewControllerSelectArd(adr:String,cityData:String,loc:String) {
        city_lbl.text = cityData
        adrLast = adr.components(separatedBy: ":").last!
        adrTv.text = adr.components(separatedBy: ":").first!
        adrTf.isHidden = true
        getInsets()
        
        let ar = loc.components(separatedBy: "-")
        self.lng = (ar.last! as NSString).doubleValue
        self.lat = (ar.first! as NSString).doubleValue
        
        checkInfo()
    }
    
    @IBAction func submit_action(_ sender: Any) {
        let arr = adrLast.components(separatedBy: "-")
        
        if arr.count == 0 {
            HUD.flash(.label("请选择地址"), delay: 1.2)
            return
        }
        if phoneTf.text?.count != 11 {
            HUD.flash(.label("请输入正确的手机号码"), delay: 1.2)
            return
        }
        var type = 3
        if isSend {
            type = 4
        }
        let dict = [
            "province_name":arr[0] as Any,
            "city_name":arr[1] as Any,
            "district_name":arr[2] as Any,
            "address":adrTv.text as Any,
            "linkman":nameTf.text as Any,
            "shopName":city_lbl.text as Any,
            "mobile":phoneTf.text as Any,
            "type":type as Any,
            "lat":lat as Any,
            "lng":lng as Any,
            "note":textTV.text as Any
        ]
        adrInfo = addPinPinOrder_adrInfo(JSON: dict)
        delegate?.P_P_H_Adr_VC_Data(adrData: adrInfo!,isSend: isSend,idx: idx)
        self.navigationController?.popViewController(animated: true)
    }
    
    @IBAction func map_select_loc(_ sender: Any) {
        nameTf.resignFirstResponder()
        phoneTf.resignFirstResponder()
        textTV.resignFirstResponder()
        adrTv.resignFirstResponder()
        let vc = SJMapViewController()
        vc.delegate = self
        vc.isPPH = true
        if city_lbl.text != "请选择定位" {
            vc.alreadySelect = true
            vc.lat = lat
            vc.lng = lng
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    func textViewDidChange(_ textView: UITextView) {
        if textView == textTV {
            if textView.text.count != 0 {
                holder_lbl.isHidden = true
            }else{
                holder_lbl.isHidden = false
            }
            if textView.text.count > 200 {
                if let str = textView.text {
                    let subStr = str.prefix(200)
                    textView.text = String(subStr)
                }
            }
            count_lbl.text = "\(textView.text.count)/200"
        }else{
            if textView.text.count != 0 {
                adrTf.isHidden = true
            }else{
                adrTf.isHidden = false
            }
            getInsets()
        }
        checkInfo()
    }
    
    @IBOutlet weak var adrTv: UITextView!
    @IBOutlet weak var clearBtn: UIButton!
    @IBAction func clearAction(_ sender: Any) {
        adrTv.text = ""
        getInsets()
        phoneTf.text = ""
        nameTf.text = ""
        city_lbl.text = "请选择定位"
        lat = 0
        lng = 0
        textTV.text = ""
        checkInfo()
    }
 
    @IBOutlet weak var holder_lbl: UILabel!
    func checkInfo(){
        if adrTv.text?.count != 0 && phoneTf.text?.count != 0 && nameTf.text?.count != 0 && city_lbl.text != "请选择定位" {
            submit_btn.isUserInteractionEnabled = true
            submit_btn.alpha = 1
        }else{
            submit_btn.isUserInteractionEnabled = false
            submit_btn.alpha = 0.5
        }
        if adrTv.text?.count != 0 || phoneTf.text?.count != 0 || nameTf.text?.count != 0 || textTV.text.count != 0 || city_lbl.text != "请选择定位" {
            clearBtn.isUserInteractionEnabled = true
            clearBtn.alpha = 1
        }else{
            clearBtn.isUserInteractionEnabled = false
            clearBtn.alpha = 0.5
        }
    }
    @IBOutlet weak var city_lbl: UILabel!
    @IBOutlet weak var top_view: UIView!
    @objc func textChangeTf(tf:UITextField){
        checkInfo()
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "信息填写"
        self.view.addSubview(navbar)
        nameTf.addTarget(self, action: #selector(textChangeTf(tf:)), for: .allEditingEvents)
        phoneTf.addTarget(self, action: #selector(textChangeTf(tf:)), for: .allEditingEvents)
        
        top_view.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height+10)
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(200)
        }
   
        textTV.delegate = self
        
        if adrInfo != nil {
            city_lbl.text = adrInfo?.shopName
            textTV.text = adrInfo?.note
            adrTv.text = adrInfo?.address
            getInsets()
            nameTf.text = adrInfo?.linkman
            phoneTf.text = adrInfo?.mobile
            lat = adrInfo!.lat!
            lng = adrInfo!.lng!
            if textTV.text.count != 0 {
                holder_lbl.isHidden = true
            }
        }
        checkInfo()
    }
    
    @IBOutlet weak var adrCenterY: NSLayoutConstraint!
    
    func textSize(text : String , font : UIFont , maxSize : CGSize) -> CGSize{
        return text.boundingRect(with: maxSize, options: [.usesLineFragmentOrigin], attributes: [NSAttributedString.Key.font : font], context: nil).size
    }
    
    func getInsets() {
        let tvSize = textSize(text: adrTv.text, font: UIFont.systemFont(ofSize: 13), maxSize: CGSize(width: adrTv.bounds.size.width, height: 900))
        if tvSize.height > 20 {
            adrCenterY.constant = -2
        }else{
            adrCenterY.constant = 4
        }
    }
    
}

