//
//  P_P_H_Time_Select_View.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/2.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import SwiftDate

protocol P_P_H_Time_Select_View_Delegate {
    func P_P_H_Time_Select_View_Time_Select(time:Double)
}
class P_P_H_Time_Select_View: UIView,UIPickerViewDelegate,UIPickerViewDataSource {
    var contentView:UIView!
    var userToken = ""{
        didSet{
            getTimeSet()
        }
    }
    var time_str:Double = -1
    
    @IBOutlet weak var picker_view: UIPickerView!
    var delegate:P_P_H_Time_Select_View_Delegate?
    @IBAction func close_action(_ sender: UIButton) {
        self.removeFromSuperview()
    }
    
    @IBAction func submitAction(_ sender: Any) {
        let day = modelArr[daySelect]
        let hour = day.h_time![hourSelect]
        let hour_str = hour.val as! NSString
        let min = hour.m_time![minSelect].val as! NSString
        
        time_str = day.stime! + hour_str.doubleValue * 3600 + min.doubleValue * 60
        //submit
        delegate?.P_P_H_Time_Select_View_Time_Select(time: time_str * 1000)
        self.removeFromSuperview()
    }
    
    var modelArr:Array<pphAppointmentTimeData_model> = []
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 3
    }
    
    var daySelect = 0
    var hourSelect = 0
    var minSelect = 0
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if modelArr.count > 0 {
            switch component {
            case 0:
                return modelArr.count
            case 1:
                let arr = modelArr[daySelect].h_time!
                return arr.count
            default:
                let arr = modelArr[daySelect].h_time!
                let arr2 = arr[hourSelect].m_time!
                return arr2.count
            }
        }
        return 0
    }
    //设置选择框各选项的内容，继承于UIPickerViewDelegate协议
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int,
                    forComponent component: Int) -> String? {
        if modelArr.count > 0 {
            switch component {
            case 0:
                return modelArr[row].val!
            case 1:
                let arr = modelArr[daySelect].h_time
                return arr![row].val
            default:
                let arr = modelArr[daySelect].h_time
                let arr2 = arr![hourSelect].m_time
                return arr2![row].val!
            }
        }
        return ""
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int,
                    inComponent component: Int) {
        if modelArr.count == 0 {
            return
        }
        //根据列、行索引判断需要改变数据的区域
        switch (component) {
        case 0:
            daySelect = row;
            pickerView.reloadComponent(1);
            pickerView.reloadComponent(2);
            pickerView.selectRow(hourSelect, inComponent: 1, animated: false)
            pickerView.selectRow(minSelect, inComponent: 2, animated: false)
        case 1:
            hourSelect = row;
            pickerView.reloadComponent(2);
            pickerView.selectRow(minSelect, inComponent: 2, animated: false)
        case 2:
            minSelect = row;
        default:
            break;
        }
    }
    
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    
    func getTimeSet(){
        picker_view.delegate = self
        picker_view.dataSource = self
        pphAppointmentTime(["user_token":userToken as Any]) {[self] (data) in
            let model = data as! pphAppointmentTime_model
            modelArr.removeAll()
            model.data?.forEach({ (item) in
                modelArr.append(item)
            })
            picker_view.reloadAllComponents()
        } failture: { (err) in
            
        }
    }
    
    ///初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    
}
