//
//  PPH_SUC_VC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/4/9.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit

class PPH_SUC_VC: BaseViewController,UITableViewDelegate,UITableViewDataSource {
    var lwb_no = ""
    var sendArr:Array<addPinPinOrder_adrInfo>?
    var receiveArr:Array<addPinPinOrder_adrInfo>?
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 1 {
            return sendArr!.count
        }
        if section == 2 {
            return receiveArr!.count
        }
        return 1
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 4
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "Suc_Top_Cell") as! Suc_Top_Cell
            cell.wb_no_lbl.text = lwb_no
            cell.order_time_lbl.text = add_order_time
            return cell
        }
        
        if indexPath.section == 3 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "PPH_D_Cell") as! PPH_D_Cell
            cell.carType_lbl.text = car_type
            cell.time_lbl.text = pay_time
            cell.cost_lbl.text = price
            return cell
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "Suc_LOG_Cell") as! Suc_LOG_Cell
        if indexPath.section == 1 {
            cell.status_lbl.text = "装"
            cell.status_lbl.backgroundColor = UIColor(named: "green")
            if indexPath.row == 0 {
                cell.top_line.isHidden = true
            }
            let model = sendArr![indexPath.row]
            cell.holder_lbl.isHidden = true
            cell.name_lbl.text = model.shopName
            cell.link_lbl.text = model.linkman! + " " + model.mobile!
            cell.adr_lbl.text = "\(model.province_name!)\(model.city_name!)\(model.district_name!)\(model.address!)"
            cell.commend_lbl.text = "-"
            if model.note?.count != 0 {
                cell.commend_lbl.text = model.note
            }
            
        }
        if indexPath.section == 2 {
            cell.status_lbl.text = "卸"
            cell.status_lbl.backgroundColor = UIColor(named: "#FAA376")
            if indexPath.row == receiveArr!.count - 1 {
                cell.btm_line.isHidden = true
            }
            let model = receiveArr![indexPath.row]
            cell.holder_lbl.isHidden = true
            cell.name_lbl.text = model.shopName
            cell.link_lbl.text = model.linkman! + " " + model.mobile!
            cell.adr_lbl.text = "\(model.province_name!)\(model.city_name!)\(model.district_name!)\(model.address!)"
            cell.commend_lbl.text = "-"
            if model.note?.count != 0 {
                cell.commend_lbl.text = model.note
            }
        }
        return cell
    }
    
    override func backAction() {
        self.navigationController?.popToRootViewController(animated: true)
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            return 201
        }
        if indexPath.section == 3 {
            return 110.5
        }
        return UITableView.automaticDimension
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 1 {
            return 0
        }
        return 5
    }
    var add_order_time = ""
    var wb_no = ""
    var car_type = ""
    var price = ""
    var pay_time = ""
    var userToken = ""
    @IBAction func cancel_order(_ sender: Any) {
        cancelOrder(["user_token":userToken as Any,"wb_no":wb_no as Any]) { (data) in
            HUD.flash(.label("取消订单成功"), delay: 1.2)
            self.navigationController?.popToRootViewController(animated: true)
        } failture: { (err) in
            
        }

    }
    @IBOutlet weak var top_view_height: NSLayoutConstraint!
    @IBOutlet weak var list_view: UITableView!
    @IBOutlet weak var top_view: UIView!
    @IBAction func top_btn_click_action(_ sender: UIButton) {
        top_view_height.constant = 0
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "物流下单"
        self.view.addSubview(navbar)
        
        SetTopFrame(view: top_view, height: 25)
        list_view.separatorStyle = .none
        
        list_view.register(UINib(nibName: "Suc_Top_Cell", bundle: nil), forCellReuseIdentifier: "Suc_Top_Cell")
        list_view.register(UINib(nibName: "Suc_LOG_Cell", bundle: nil), forCellReuseIdentifier: "Suc_LOG_Cell")
        list_view.register(UINib(nibName: "PPH_D_Cell", bundle: nil), forCellReuseIdentifier: "PPH_D_Cell")
    }


    
}
