//
//  Add_Report_View.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/26.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
import LGButton
protocol Add_Report_View_Delegate {
    func Add_Report_View_Select_Img(view:Add_Report_View)
    func Add_Report_View_Submit_Action(view:Add_Report_View)
    func Add_Report_View_Close(view:Add_Report_View)
    func Add_Report_View_ChangeImg(view:Add_Report_View,idx:Int)
    func Add_Report_View_DelImg(view:Add_Report_View,idx:Int)
}
class Add_Report_View: UIView {
    @IBOutlet weak var btm_view: UIView!
    
    var scrollView = UIScrollView()
    
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
        
        scrollView.subviews.forEach { (item) in
            item.removeFromSuperview()
        }
        
        btm_view.insertSubview(scrollView, at: btm_view.subviews.count-1)
    
        scrollView.frame = CGRect(x: 15, y: add_img_btn.frame.maxY+20, width: ScreenWidth - 30, height: 100.5)
        
        for i in 0 ..< imgs_datas.count {
            let view = UIView(frame: CGRect(x: Double(i) * (100.5 + 15), y: 0, width: 100.5, height: 100.5))
            scrollView.addSubview(view)
            
            let imgview = UIImageView(frame: CGRect(x: 0, y: 7.5, width: 93, height: 93))
            view.addSubview(imgview)
            imgview.sd_setImage(with:URL(string:SERVERCE_ImageHost + imgs_datas[i]), placeholderImage: nil,options:.allowInvalidSSLCertificates)
            
            let btn1 = UIButton(frame: imgview.frame)
            btn1.tag = i
            btn1.backgroundColor = UIColor(named: "标题字颜色")
            btn1.alpha = 0.4
            btn1.addTarget(self, action: #selector(changeImgAction(btn:)), for: .touchUpInside)
            view.addSubview(btn1)
            
            let img2 = UIImageView(frame: CGRect(x: 100.5-15, y: 0, width: 15, height: 15))
            img2.image = UIImage(named: "shanchuDel")
            view.addSubview(img2)
            
            let delBtn = UIButton(frame: CGRect(x: 100.5-30, y: 0, width: 30, height: 30))
            delBtn.tag = i
            delBtn.addTarget(self, action: #selector(delImgAction(btn:)), for: .touchUpInside)
            view.addSubview(delBtn)
            
        }
        
        scrollView.contentSize = CGSize(width: Double(imgs_datas.count) * 103.5, height: 103.5)
    }
    @objc func delImgAction(btn:UIButton){
        delegate?.Add_Report_View_DelImg(view: self, idx: btn.tag)
    }
    @objc func changeImgAction(btn:UIButton){
        delegate?.Add_Report_View_ChangeImg(view: self, idx: btn.tag)
    }
    
    @IBOutlet weak var report_sn_tf: UITextField!
    var delegate:Add_Report_View_Delegate?
    var imgs_datas:Array<String> = []
    @IBOutlet weak var select_view: UIView!
    var select_idx:Int? = -1 {
        didSet{
            if select_idx != nil {
                select_img.isHidden = false
                switch select_idx {
                case 0:
                    type_lbl.text = "检验检测报告"
                    break
                case 1:
                    type_lbl.text = "关检报告"
                    break
                default:
                    type_lbl.text = "检验检疫合格证"
                    break
                }
            }
        }
    }
   
    
    @IBAction func add_img_action(_ sender: UIButton) {
        delegate?.Add_Report_View_Select_Img(view: self)
    }
    @IBOutlet weak var add_img_btn: UIButton!
    @IBAction func submit_action(_ sender: UIButton) {
        if report_sn_tf.text?.count == 0 {
            HUD.flash(.label("请输入报告编码"), delay: 1.2)
            return
        }
        if select_idx == -1 {
            HUD.flash(.label("请选择报告类型"), delay: 1.2)
            return
        }
        if imgs_datas.count == 0 {
            HUD.flash(.label("请选择报告图片"), delay: 1.2)
            return
        }
        delegate?.Add_Report_View_Submit_Action(view: self)
        close_action(sender)
    }
    @IBOutlet weak var img_y: NSLayoutConstraint!
    @IBAction func type_select(_ sender: UIButton) {
        select_view.isHidden = true
        select_idx = sender.tag
        let whitespace = NSCharacterSet.whitespacesAndNewlines
        type_lbl.text = sender.titleLabel?.text!.trimmingCharacters(in: whitespace)
        img_y.constant = sender.frame.origin.y
        
    }
    @IBOutlet weak var select_img: UIImageView!
    @IBAction func select_type_action(_ sender: UIButton) {
        select_view.isHidden = !select_view.isHidden
    }
    @IBAction func close_action(_ sender: UIButton) {
        delegate?.Add_Report_View_Close(view: self)
    }
    @IBOutlet weak var type_lbl: UILabel!
    var contentView:UIView!
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
}
