//
//  scv_cell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2021/1/27.
//  Copyright © 2021 junye lu. All rights reserved.
//

import UIKit
protocol scv_cell_delegate {
    func scv_cell_check_img(idx:Int)
}
class scv_cell: UITableViewCell {

    var delegate:scv_cell_delegate?
    @IBOutlet weak var right_arrow: UIImageView!
    @IBOutlet weak var left_arrow: UIImageView!
    @IBOutlet weak var title_lbl: UILabel!
    let scrollview = UIScrollView(frame: CGRect(x: 45, y: 53.5, width: ScreenWidth-90, height: 123.5))
    @IBAction func tap_action(_ sender: UIButton) {
        if sender == left_btn {
            left_btn.isHidden = true
            left_arrow.isHidden = true
            right_arrow.isHidden = false
            right_btn.isHidden = false
            scrollview.setContentOffset(CGPoint(x: 0, y: 0), animated: true)
        }else{
            right_btn.isHidden = true
            right_arrow.isHidden = true
            left_btn.isHidden = false
            left_arrow.isHidden = false
            scrollview.setContentOffset(CGPoint(x: ScreenWidth-90, y: 0), animated: true)
        }
    }
    
    @IBOutlet weak var right_btn: UIButton!
    
    @IBOutlet weak var left_btn: UIButton!
    let titles = ["营业执照","生产许可证","商品流通许可证"]
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        // Initialization code
        
        scrollview.showsHorizontalScrollIndicator = false
        scrollview.isPagingEnabled = true
        scrollview.contentSize = CGSize(width: (ScreenWidth-90)*2, height: 123.5)
        self.contentView.addSubview(scrollview)
        let width = (ScreenWidth-115)*0.5
        for i in 0 ..< 3 {
           
            let btn = UIButton(frame: CGRect(x: CGFloat(i)*(width+25), y: 0, width: width, height: 95))
            btn.backgroundColor = UIColor.blue
            if i == 1 {
                btn.backgroundColor = UIColor.gray
            }
                
            btn.tag = i
            btn.addTarget(self, action: #selector(btn_click(btn:)), for: .touchUpInside)
            scrollview.addSubview(btn)
            
            let lbl = UILabel()
            lbl.textAlignment = .center
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.text = titles[i]
            lbl.font = UIFont(name: "PingFangSC-Medium", size: 13)
            scrollview.addSubview(lbl)
            lbl.snp.makeConstraints { (make) in
                make.centerX.equalTo(btn.snp.centerX)
                make.top.equalTo(btn.snp_bottom).offset(10)
                make.width.equalTo(btn.snp_width)
                make.height.equalTo(18.5)
            }
        }
        
        
    }
    
    
    
    @objc func btn_click(btn:UIButton){
        delegate?.scv_cell_check_img(idx: btn.tag)
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
